/******************************************************************************* 
*
*  NX    :  CHrefStaticNX
*
*  Tv          :  CStaticɁAnCp[N@\
*
*                   @\
*                     E
*                     Ew^J[\ɕς
*                     EuEUA[N
*                     Ec[qg\
*
*                   Copyright (C) 2001 rarara
*                   E-mail:   t_soga@nifty.com
*
*    Modified by T's-Neko 2004   www.sage-p.com
*
*******************************************************************************/

#include "stdafx.h"
#include "HrefStatic.h"

/****************************************************************
*  ֐@F	RXgN^
****************************************************************/
CHrefStatic::CHrefStatic()
{
	m_dispToolTip = FALSE;

  m_hBrush = ::CreateSolidBrush(GetSysColor(COLOR_3DFACE)); // wĩuV
	m_cursor = GetFingerCursor();                             // w^J[\擾
}

/****************************************************************
*  ֐@F	fXgN^
****************************************************************/
CHrefStatic::~CHrefStatic()
{
	DeleteObject(m_hBrush);

	if( m_cursor != LoadCursor(NULL,IDC_ARROW))
		DestroyCursor(m_cursor);
}

BEGIN_MESSAGE_MAP(CHrefStatic, CStatic)
	//{{AFX_MSG_MAP(CHrefStatic)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************
*  ֐@F	zFtHgݒ菈
****************************************************************/
HBRUSH CHrefStatic::CtlColor(CDC* pDC, UINT nCtlColor)
{
	if( m_font.m_hObject == NULL )
	{
		// 1xtHg̃tHg牺tHg쐬
		LOGFONT lf;
		GetFont()->GetLogFont(&lf);
		lf.lfUnderline = TRUE;
		m_font.CreateFontIndirect(&lf);
	}

  pDC->SelectObject(&m_font);                   // tHg
  pDC->SetTextColor(RGB(0, 0, 255));            // eLXg
  pDC->SetBkMode(TRANSPARENT);                  // wiF

	return m_hBrush;
}

/*****************************************************************************
*	֐	:	bZ[WtB^O
*****************************************************************************/
BOOL CHrefStatic::PreTranslateMessage(MSG* pMsg)
{
	if( pMsg->message == WM_MOUSEMOVE)
	{
		if( m_dispToolTip == TRUE )
			m_toolTip.RelayEvent(pMsg);
	}

	return CStatic::PreTranslateMessage(pMsg);
}

/****************************************************************
*  ֐@F	J[\ݒ菈
****************************************************************/
BOOL CHrefStatic::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
    ::SetCursor(m_cursor);
    return TRUE;
}

/*****************************************************************************
*	֐	:	w^J[\擾
*****************************************************************************/
HCURSOR CHrefStatic::GetFingerCursor()
{
	HCURSOR hCursor;

	OSVERSIONINFO  osInfo;
    osInfo.dwOSVersionInfoSize = sizeof( OSVERSIONINFO );
    GetVersionEx( &osInfo );
	// Windows2000̂Ƃ
	if( osInfo.dwPlatformId == VER_PLATFORM_WIN32_NT && osInfo.dwMajorVersion >= 5 )
	{
		hCursor = LoadCursor(NULL,MAKEINTRESOURCE(32649));                        // nhJ[\
	}
	// ̑OŜƂ
	else
	{
		char szPath[MAX_PATH];
		GetWindowsDirectory(szPath,MAX_PATH);
		strcat(szPath,"\\winhlp32.exe");
		HINSTANCE hInstance = LoadLibrary(szPath);

		if( hInstance != NULL )
		{
			hCursor = CopyCursor(LoadCursor(hInstance,MAKEINTRESOURCE(106)));    // nhJ[\
			FreeLibrary(hInstance);
		}
		else
		{
			hCursor = LoadCursor(NULL,IDC_ARROW);                                // WJ[\
		}
	}

  return hCursor;
}

/*****************************************************************************
*	֐	:	}EXNbN
*****************************************************************************/
void CHrefStatic::OnLButtonDown(UINT nFlags, CPoint point)
{
  if ( m_href == "" )  return;
  CWaitCursor  wa;

  // mailto: Ŏn܂Ȃ烁[N
  if ( m_href.Left(7) == "mailto:" )
	{
		::ShellExecute(NULL,"open",m_href,NULL,NULL,SW_SHOWNORMAL);
  }

	// URLȂuEUN
	else if( PathIsURL(m_href) == TRUE )
	{
		::ShellExecute(NULL,NULL,m_href,NULL,NULL,SW_SHOWNORMAL);
	}

  // ȊOȂt@CJ
  else
  {
    int  r;

    r = (int)::ShellExecute(NULL,"open",m_href,NULL,NULL,SW_SHOWNORMAL);
    if ( r == SE_ERR_NOASSOC ) {
      if ( m_href.Right(4) == ".pdf" )
        MessageBox( "Adobe Reader CXg[Ă", NULL, MB_OK );
    }
  }

	CStatic::OnLButtonDown(nFlags, point);
}

/*****************************************************************************
*	֐	:	c[qgݒ菈
*****************************************************************************/
void CHrefStatic::SetToolTip(LPCTSTR lpStr)
{
	m_dispToolTip = TRUE;
	CWnd *pWnd = GetParent();
	m_toolTip.Create(pWnd,TTS_ALWAYSTIP);
	m_toolTip.AddTool( this, lpStr);
	m_toolTip.Activate(TRUE);
}
 
