/*************************************************************************
*  <<< PXg\ (ListX) >>> 
**************************************************************************/

#include "mixer_precomp.h"  /* Auto precompiled header, Look at mixer-... folder */
// #pragma hdrstop

#if defined(USES_MXP_AUTOINC)
 #include "listx.ah"  /* Auto include header, Look at mixer-... folder */
#endif
 
/*-----------------------------------------------------------------------*/
/*  <<< (ListX) PXg\ERei >>> */ 
/*-----------------------------------------------------------------------*/

#ifdef  USES_SYM
SYM_STRUCT_START( ListX )
SYM_STRUCT_LOOP_FUNC( ListX, ListX_doLoopFunc )
SYM_STRUCT_MEMB_FUNC( ListX, ListX_doReadMemb, NULL )  /* first */
SYM_STRUCT_END( ListX )
#endif


 
/*************************************************************************
*  <<< [ListX_init_byAble_imp] ListX_init_byAble ̊֐ >>> 
**************************************************************************/
#ifdef  USES_ARRX
void  ListX_init_byAble_imp( ListX* m, ArrX_Able* able, Offset list_elem,
  Offset able_elem, int elem_size )
{
  ListX_Builder  b;
  char*  p = (char*)able->arr.first;
  char*  p_over = (char*)able->arr.last;

  b = ListX_initForBuilder( m );
  while ( p < p_over ) {
    if ( Offset_ref( able_elem, p, bool ) ) {

      /* ȉ́AListX_Builder_add( &b, p ); ɑ */
      **(&b) = p;
      *(&b) = &Offset_ref( list_elem, p, ListX_Elem );
    }
    p += elem_size;
  }
  ListX_Builder_finish( &b );
}
#endif
 
/*************************************************************************
*  <<< [ListX_init_byArrXBuf_imp] ListX_init_byArrXBuf ̊֐ >>> 
**************************************************************************/
#ifdef  USES_ARRX
void  ListX_init_byArrXBuf_imp( ListX* m, ArrX_Buf* buf, Offset elem_list,
  int elem_size )
{
  ListX_Builder  b;
  char*  p = (char*)buf->first;
  char*  p_over = (char*)buf->last;

  b = ListX_initForBuilder( m );
  while ( p < p_over ) {
    ListX_Builder_add2( &b, p, elem_list );
    p += elem_size;
  }
  ListX_Builder_finish( &b );
}
#endif
 
/*************************************************************************
*  <<< [ListX_toEmptyDelete_imp] ListX_toEmptyDelete ̊֐ >>> 
**************************************************************************/
#ifdef USES_INF
#ifdef LISTX_USE_MALLOC
void  ListX_toEmptyDelete_imp( ListX* m, Offset elem_offset,
  Inf_FinishFunc Elem_finish )
{
  void*  p;
  void*  next;

  if ( Elem_finish != NULL ) {
    for ( p = m->first;  p != NULL;  p = next ) {
      next = Offset_ref( elem_offset, p, ListX_Elem );
      Elem_finish( p );
      free( p );
    }
  }
  else {
    for ( p = m->first;  p != NULL;  p = next ) {
      next = Offset_ref( elem_offset, p, ListX_Elem );
      free( p );
    }
  }
  ListX_toEmpty( m );
}
#endif  /* USES_INF */
#endif


 
/*************************************************************************
*  <<< [ListX_insert_imp] ListX_insert ̊֐ >>> 
**************************************************************************/
void  ListX_insert_imp( ListX* m, void* pos, void* ins, Offset elem_next )
{
  void*  p;
  void*  p_prev;

  ASSERT( m != NULL );
  ASSERT( m->first != NULL || ( m->first == NULL && pos == NULL ) );
  ASSERT( ins != NULL );

  /* vfāA擪̏ꍇ */
  /* vfāȀꍇi擪 ASSERT  pos == NULLj */
  if ( m->first == pos || m->first == NULL )  {
    Offset_ref( elem_next, ins, void* ) = m->first;
    m->first = ins;
  }

  /* 擪ł͂Ȃꍇ */
  else {
    p = Offset_ref( elem_next, m->first, void* );
    p_prev = m->first;
    for (;;) {
      if ( p == pos ) {
        Offset_ref( elem_next, ins, void* ) = p;
        Offset_ref( elem_next, p_prev, void* ) = ins;
        return;
      }
      ASSERT( p != NULL );  /* pos Ȃ */
      p_prev = p;
      p = Offset_ref( elem_next, p, void* );
    }
  }
}

 
/*************************************************************************
*  <<< [ListX_addFirstMalloc_imp] ListX_addFirstMalloc ̎ >>> 
**************************************************************************/
#ifdef LISTX_USE_MALLOC
void*  ListX_addFirstMalloc_imp( ListX* m, Offset elem_offset, int size )
{
  void*  p = malloc( size );
  Offset_ref( elem_offset, p, ListX_Elem ) = m->first;
  m->first = p;
  return  p;
}
#endif
 
/*************************************************************************
*  <<< [ListX_insertMalloc_imp] ListX_insertMalloc ̊֐ >>> 
**************************************************************************/
#ifdef  LISTX_USE_MALLOC
void*  ListX_insertMalloc_imp( ListX* m, void* pos, Offset elem_offset, int size )
{
  void*  obj = malloc( size );
  ListX_insert_imp( m, pos, obj, elem_offset );
  return  obj;
}
#endif
 
/*************************************************************************
*  <<< [ListX_remove_imp] ListX_remove ̊֐ >>> 
**************************************************************************/
void  ListX_remove_imp( ListX* m, void* elem, Offset elem_next )
{
  void*  p;
  void*  p_prev;

  ASSERT( m->first != NULL && elem != NULL );

  /* 擪̏ꍇ */
  if ( m->first == elem )  {
    m->first = Offset_ref( elem_next, m->first, void* );
  }
  /* 擪ł͂Ȃꍇ */
  else {
    p = Offset_ref( elem_next, m->first, void* );
    p_prev = m->first;
    for (;;) {
      ASSERT( p != NULL );  /* Ȃ */
      if ( p == elem ) {
        Offset_ref( elem_next, p_prev, void* ) =
          Offset_ref( elem_next, p, void* );
        return;
      }
      p_prev = p;
      p = Offset_ref( elem_next, p, void* );
    }
  }
}

 
/*************************************************************************
*  <<< [ListX_reverse_imp] ListX_reverse ̊֐ >>> 
**************************************************************************/
void  ListX_reverse_imp( ListX* m, Offset ofs )
{
  ListX  newList;
  void*  ptr;

  newList.first = NULL;
  ptr = m->first;
  while ( ptr != NULL ) {
    void*  next = Offset_ref( ofs, ptr, void* );
    Offset_ref( ofs, ptr, void* ) = newList.first;
    newList.first = ptr;
    ptr = next;
  }
  m->first = newList.first;
}


 
/*************************************************************************
*  <<< [ListX_move_imp] ListX_move ̊֐ >>> 
**************************************************************************/
void  ListX_move_imp( ListX* m, void* pos, void* moving, Offset elem_offset )
{
  if ( pos == moving )  return;
  ListX_remove_imp( m, moving, elem_offset );
  ListX_insert_imp( m, pos, moving, elem_offset );
}

 
/*************************************************************************
*  <<< [ListX_moveStep_imp] ListX_moveStep ̊֐ >>> 
**************************************************************************/
void  ListX_moveStep_imp( ListX* m, void* moving, Offset elem_offset, int plus )
{
  void*  pos;
  int    i;

  i = ListX_getI_imp( m, moving, elem_offset );
  ASSERT( i != -1 );

  if ( plus <= 0 ) {
    i += plus;
    if ( i <= 0 )  pos = m->first;
    else  pos = ListX_get_imp( m, i, elem_offset );
  }
  else {
    i += plus + 1;
    if ( i >= ListX_getN_imp( m, elem_offset ) )  pos = NULL;
    else  pos = ListX_get_imp( m, i, elem_offset );
  }

  ListX_move_imp( m, pos, moving, elem_offset );
}

 
/*************************************************************************
*  <<< [ListX_moveSet_imp] ListX_moveSet ̊֐ >>> 
**************************************************************************/
void  ListX_moveSet_imp( ListX* m, void* from_start, void* from_endNext,
  void* to, Offset elem_offset )
{
  void*  start_prev = ListX_getPrev_imp( m, from_start, elem_offset );
  void*  end_prev = ListX_getPrev_imp( m, from_endNext, elem_offset );
  void*  to_prev = ListX_getPrev_imp( m, to, elem_offset );

  #ifndef  NDEBUG
  {
    void*  p;
    bool   bStart = false;
    bool   bEnd = false;
    bool   bTo = false;

    for ( p = m->first; p != NULL;
          p = Offset_ref( elem_offset, p, void* ) ) {
      if ( p == from_start )  bStart = true;
      else if ( p == from_endNext && bStart )  bEnd = true;
      else if ( p == to ) {
        if ( ! bStart || bEnd )  bTo = true;
      }
    }
    ASSERT( bStart );
    ASSERT( bEnd );
    ASSERT( bTo );
  }
  #endif

  ASSERT( end_prev != NULL );
  Offset_ref( elem_offset, end_prev, void* ) = to;

  if ( to_prev == NULL )
    m->first = from_start;
  else
    Offset_ref( elem_offset, to_prev, void* ) = from_start;

  if ( start_prev == NULL )
    m->first = from_endNext;
  else
    Offset_ref( elem_offset, start_prev, void* ) = from_endNext;
}

 
/*************************************************************************
*  <<< [ListX_getLast_imp] ListX_getLast ̊֐ >>> 
**************************************************************************/
#ifdef  USES_OFFSET
void*  ListX_getLast_imp( ListX* m, Offset elem_offset )
{
  void*  p = m->first;
  void*  p2;

  if ( p == NULL )  return  NULL;
  for (;;) {
    p2 = Offset_ref( elem_offset, p, void* );
    if ( p2 == NULL )  break;
    p = p2;
  }

  return  p;
}
#endif

 
/*************************************************************************
*  <<< [ListX_get_imp] ListX_get ̊֐ >>> 
**************************************************************************/
#ifdef  USES_OFFSET
void*  ListX_get_imp( ListX* m, int i, Offset elem_offset )
{
  void*  p = m->first;

  while ( i > 0 ) {
    ASSERT( p != NULL );
    p = Offset_ref( elem_offset, p, void* );
    i--;
  }

  return  p;
}
#endif

 
/*************************************************************************
*  <<< [ListX_getI_imp] ListX_getI ̊֐ >>> 
**************************************************************************/
int   ListX_getI_imp( ListX* m, void* elem, Offset elem_offset )
{
  int  i = 0;
  void*  p = m->first;

  while ( p != NULL ) {
    if ( p == elem )  return  i;
    p = Offset_ref( elem_offset, p, void* );
    i++;
  }

  return  -1;
}
 
/*************************************************************************
*  <<< [ListX_getN_imp] ListX_getN ̊֐ >>> 
**************************************************************************/
#ifdef  USES_OFFSET
int  ListX_getN_imp( ListX* m, Offset elem_offset )
{
  int  i = 0;
  void*  p = m->first;

  while ( p != NULL ) {
    p = Offset_ref( elem_offset, p, void* );
    i++;
  }

  return  i;
}
#endif

 
/*************************************************************************
*  <<< [ListX_getPrev_imp] ListX_getPrev ̊֐ >>> 
**************************************************************************/
void*  ListX_getPrev_imp( ListX* m, void* elem, Offset elem_offset )
{
  void*  p;
  void*  prev = NULL;

  for ( ListX_forEach_imp( m, &p, elem_offset ) ) {
    if ( p == elem )  break;
    prev = p;
  }
  return  prev;
}

 
/***********************************************************************
*  <<< [ListX_search_s_imp]  >>> 
*yz
*  EOffset_Key*  key;     vf̃L[
*  Echar*  kword;         L[
*  EOffset  elem_offset;  vf ListX_Elem ^ۃNX̃ItZbg
*  Evoid*  Ԃl;        qbgvf̃AhXiNULL=qbgȂj
************************************************************************/
#ifndef  USES_MORI_STDLIB
#ifdef  __STRING_H
#if !defined(FOR_GHS) && !defined(FOR_CA) && !defined(FOR_WINCE)

void*  ListX_search_s_imp( ListX* m, Offset_Key* key, const char* kword,
  Offset elem_offset )
{
  void*  p;

  for ( ListX_forEach_imp( m, &p, elem_offset ) ) {
    if ( Offset_Key_isHit( key, p, kword ) )  return  p;
  }
  return  NULL;
}

#endif
#endif
#endif





 
/*************************************************************************
*  <<< [ListX_printElem_imp] ListX_printElem ̊֐ >>> 
**************************************************************************/
#ifndef  ERRORS_CUT_DEBUG_TOOL
void  ListX_printElem_imp( ListX* m, Offset elem_offset, const char* title )
{
  int  i = 0;
  ListX_Elem*  p;

  Errors_printf( "%sListX(%p)...", title, m );
  Errors_printf( "%s  first = %p", title, m->first );
  for ( ListX_forEach_imp( m, &p, elem_offset ) ) {
    Errors_printf( "%s  elem(%d).adr = %p", title, i, p );
    i++;
  }
}
#endif

 
/**************************************************************************
*  <<< [ListX_doLoopFunc] SYM_STRUCT_LOOP_FUNC Ɏw肷֐ >>> 
***************************************************************************/
#ifdef  USES_SYM
bool  ListX_doLoopFunc( Sym_Ref* container, Sym_Ref* elem )
{
  ListX*  m;

  if ( container->type == Sym_StructType )  m = (ListX*)container->adr;
  else  m = *(ListX**)container->adr;

  if ( elem->adr == NULL )  elem->adr = m->first;
  else   elem->adr = Offset_ref( (Offset)container->elem_param, elem->adr, void* );

  return  elem->adr != NULL;
}
#endif

 
/**************************************************************************
*  <<< [ListX_doReadMemb] SYM_STRUCT_MEMB_FUNC Ɏw肷֐ >>> 
***************************************************************************/
#ifdef  USES_SYM
void  ListX_doReadMemb( Sym_Ref* obj, char* name, Sym_Ref* ret )
{
  ListX*  m = (ListX*)obj->adr;

  if ( strcmp( name, "first" ) == 0 ) {
    ret->adr = m->first;
    ret->type = obj->elem_type;
    ret->st = obj->elem_st;
  }
}
#endif

 
/*-----------------------------------------------------------------------*/
/*  <<< (ListX_Adder) PXg\Eǉq >>> */ 
/*-----------------------------------------------------------------------*/


 
/*************************************************************************
*  <<< [ListX_Adder_init_imp] ListX_Adder_init ̎ >>> 
*yz
*  EListX_Adder*  m;   PXg\Eǉq
*  EListX*        list;   vfǉ郊XgERei
*  EOffset     elemOfs;   Xgvf ListX_Elem_extend ւ̃ItZbg
**************************************************************************/
#ifdef  USES_OFFSET
void  ListX_Adder_init_imp( ListX_Adder* m, ListX* list, Offset elemOfs )
{
  *m = (ListX_Adder)list->first;
  while ( *m != NULL ) {
    *m = &Offset_ref( elemOfs, *m, void*);
  }
}
#endif

 
/*-----------------------------------------------------------------------*/
/*  <<< (ListX_Dic) nbVe[upiq[vgpj >>> */ 
/*-----------------------------------------------------------------------*/

#ifdef  USES_INF
#ifdef  USES_ARRX
#ifdef  USES_STRX
#ifdef  USES_STDPLUS
#ifdef  LISTX_USE_MALLOC
 
/***********************************************************************
*  <<< [ListX_Dic_init_imp] ListX_Dic_init ̊֐ >>> 
************************************************************************/
void  ListX_Dic_init_imp( ListX_Dic* m, int width, Offset_Key* key,
  StrX_HashFunc hash, Offset ofsElem )
{
  int  size = sizeof( ListX_Plus ) * width;
  void*  p = malloc( size );
  ListX_Plus*  lp;

  ArrX_init( &m->table, p, size );
  for ( ArrX_forEach( &m->table, &lp, ListX_Plus ) ) {
    ListX_Plus_init2( lp, ofsElem );
  }
  m->width = ArrX_getN( &m->table, ListX_Plus );
  m->key = *key;
  m->hash = hash;
}

 
/***********************************************************************
*  <<< [ListX_Dic_toEmpty_imp] ListX_Dic_toEmpty ̊֐ >>> 
************************************************************************/
void  ListX_Dic_toEmpty_imp( ListX_Dic* m, Offset elem_offset,
  Inf_FinishFunc Elem_finish )
{
  ListX_Plus*  lp;

  for ( ArrX_forEach( &m->table, &lp, ListX_Plus ) ) {
    ListX_toEmptyDelete_imp( (ListX*)lp, elem_offset, Elem_finish );
  }
}

 
/***********************************************************************
*  <<< [ListX_Dic_finish_imp] n >>> 
************************************************************************/
void   ListX_Dic_finish_imp( ListX_Dic* m, Offset elem_offset,
  Inf_FinishFunc Elem_finish )
{
  ListX_Dic_toEmpty_imp( m, elem_offset, Elem_finish );
  free( m->table.first );
}

 
/***********************************************************************
*  <<< [ListX_Dic_search_imp] ListX_Dic_search ̊֐ >>> 
************************************************************************/
#ifndef  USES_MORI_STDLIB
#ifdef  __STRING_H
#if !defined(FOR_GHS) && !defined(FOR_CA) && !defined(FOR_WINCE)

void*  ListX_Dic_search_imp( ListX_Dic* m, const char* kword, Offset elem_offset )
{
  int  hashVar = m->hash( kword, m->width );

  return  ListX_search_s_imp( (ListX*)ArrX_get( &m->table, hashVar, ListX_Plus ),
    &m->key, kword, elem_offset );
}

#endif
#endif
#endif

 
/***********************************************************************
*  <<< [ListX_Dic_searchNext_imp] ListX_Dic_searchNext ̊֐ >>> 
************************************************************************/
void*  ListX_Dic_searchNext_imp( ListX_Dic* m, void* prev, Offset ofsElem )
{
  /* ListX_Elem_forEachFrom */
  Errors_notSupport();
  return NULL;
}

 
/**************************************************************************
*  <<< [ListX_Dic_alloc_imp] ListX_Dic_alloc ̊֐ >>> 
***************************************************************************/
#ifndef  USES_MORI_STDLIB
#ifdef  __STRING_H
#if !defined(FOR_GHS) && !defined(FOR_CA) && !defined(FOR_WINCE)

void*  ListX_Dic_alloc_imp( ListX_Dic* m, const char* kword,
  Offset elem_offset, size_t elem_size )
{
  int  hashVar = m->hash( kword, m->width );
  ListX_Plus*  list = ArrX_get( &m->table, hashVar, ListX_Plus );

  if ( ListX_search_s_imp( (ListX*)list, &m->key, kword, elem_offset ) == NULL ) {
    void*  p = malloc( elem_size );
    ListX_Plus_addFirst( list, p );
    return  p;
  }
  else
    return  NULL;
}

#endif
#endif
#endif


 
/**************************************************************************
*  <<< [ListX_Dic_getN] vf̐Ԃ >>> 
***************************************************************************/
int  ListX_Dic_getN( ListX_Dic* m )
{
  int  n = 0;
  ListX_Plus*  lp;

  for ( ArrX_forEach( &m->table, &lp, ListX_Plus ) ) {
    n += ListX_getN_imp( (ListX*)lp, lp->next );
  }
  return  n;
}

 
/**************************************************************************
*  <<< [ListX_Dic_print] fobO\ >>> 
***************************************************************************/
#ifndef  ERRORS_CUT_DEBUG_TOOL
void  ListX_Dic_print( ListX_Dic* m, const char* title )
{
  Errors_printf( "%snElem = %d", title, ListX_Dic_getN( m ) );
}
#endif

 
#endif 
#endif
#endif
#endif
#endif
 
