/************************************************************************
*  <<< /t (TimeDate) >>> 
*************************************************************************/

#ifndef __TIMEDATE_H
#define __TIMEDATE_H

#include <time.h>

/*----------------------------------------------------------------------
[Module Property]
name = TimeDate
title = /t
category = {^
src = timedate.c
depend = Types
priority =
accord =
----------------------------------------------------------------------*/

#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#define  USES_TIMEDATE

#define  STDLIBS_INCLUDE_TIME_H

/*[END_OF_PRIORITY_HEADER]*/
#endif /* USES_~PRIORITY_HEADER */



 
/************************************************************************
*  <<< /t [TimeDate, time_t] >>> 
*************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/* <<< [TimeDate_loadBuf_size] >>> */
#define  TimeDate_loadBuf_size  20

char* TimeDate_getStr( time_t* time, char* str, int str_sizeof );
char* TimeDate_getStrF( time_t* time, const char* fmt, char* str,
  int str_sizeof );
char* TimeDate_getNowStr();
char* TimeDate_getNowStrF( char* fmt );
char*  TimeDate_getCompileStrF( char* fmt );
char*  TimeDate_saveStr( time_t* t, char* str );
int    TimeDate_loadStr( time_t* t, const char* str );
void   TimeDate_getFromMailHead( time_t* t,  const char* str );
int  TimeDate_set( time_t*, int year, int month, int day,
  int hour, int min, int sec );

int   TimeDate_cmp( time_t* timeA, bool existA, time_t* timeB, bool existB );
void  TimeDate_getOldest( time_t* time );
void  TimeDate_setFromDouble( struct tm* t, double diff );
void  TimeDate_wait( int msec );

#define  TimeDate_Delete   -2
#define  TimeDate_Resume   -1
#define  TimeDate_Equal     0
#define  TimeDate_Update    1
#define  TimeDate_Create    2

/* p */
char*  TimeDate_getCompileStrF_imp( char* __date__, char* __time__,
  char* fmt );

#ifdef __cplusplus
}
#endif


 
/***********************************************************************
*  <<< [TimeDate_getCompileStrF] RpCw肵Ŏ擾 >>> 
*yz
*  Echar*  fmt;      ̏iTimeDate_fmt ALj
*  Echar*  Ԃl;   ̕
*y⑫z
*E̊֐́Å֐ĂяôP̃t@CRpC
*  擾̂ŁAC֐Ȃǂ킩₷ꏊŌĂяoĂB
*EԂ镶́AύXȂłB
*EԂ镶 99ȓɂȂ悤ɒӂĂB
************************************************************************/
#define  TimeDate_getCompileStrF( fmt ) \
   TimeDate_getCompileStrF_imp( __DATE__, __TIME__, fmt )

#endif /* __TIMEDATE_H */
 
