/**************************************************************************
*  <<< 傫X^bN (BigStack) >>> 
***************************************************************************/

#ifndef __BIGSTACK_H
#define __BIGSTACK_H

#ifdef  count
#undef  count
#endif
#ifdef  sp
#undef  sp
#endif

 
/**************************************************************************
*  <<< R|[lgEvpeB >>> 
***************************************************************************/

/*----------------------------------------------------------------------
[Module Property]
name = BigStack
title = 傫X^bN
category = Rei
src = bigstack.c
depend =
priority = StdLibs
accord =
----------------------------------------------------------------------*/


 
/**************************************************************************
*  <<< W[ݒ >>> 
***************************************************************************/

#ifndef  BIGSTACK_SETTING
#define  BIGSTACK_SETTING
  #define  BIGSTACK_CHKSIZE   /* őgpTCYv */
#endif


 
/*************************************************************************	
*  <<< Dwb_ >>> 
**************************************************************************/
#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#define  USES_BIGSTACK
#define  STDLIBS_INCLUDE_STDDEF_H
#ifndef  BIGSTACK_TYPEDEF
#define  BIGSTACK_TYPEDEF
typedef  struct _BigStack  BigStack;
#endif

/*[END_OF_PRIORITY_HEADER]*/
#endif


#define  BigStack_Full         (281)   /* [ComponeGID:Errors_code] */
#define  BigStack_badStartEnd  (282)   /* [ComponeGID:Errors_code] */


 
/*--------------------------------------------------------------*/
/*<<< Interface Area -------------------------------------- >>> */ 
/*--------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

 
/**************************************************************************
*  <<< [BigStack_Sys] rbOX^bNEVXe >>> 
*y⑫z
*E}`^XNł́AX^[gAbvE^XN BigStack_Sys_init 
*  ĂяoKv܂B
***************************************************************************/
#ifdef  USES_MULTASK

extern  BigStack*  BigStack_Sys_arr;    /* z */
extern  int        BigStack_Sys_mArr;

void  BigStack_Sys_init( BigStack* works, int mWork );

#endif

extern  BigStack   BigStack_Sys_arrX;
 
/**************************************************************************
*  <<< [BigStack] rbOX^bN̈ >>> 
*y⑫z
*EBigStack ʃW[gpĂ郂W[gpƂ́A
*  CiAvP[VjŁABigStack W[Kv
*  ܂B{CugpSẴ^XÑX^[gAbvɈȉ̂悤
*  LqĂB
*
*    static  char  s[65536];  // TCÝAX^bN̎gp󋵂ɂ
*    BigStack_init( s, sizeof(s) );
*
***************************************************************************/
struct  _BigStack {
  char*  mem;    /* 傫X^bN̂擪AhX */
  unsigned int    size;
  char*  sp;
  char*  block1;
  #ifdef  BIGSTACK_CHKSIZE
    int  max;    /* őgpTCY */
  #endif
  #ifndef  NDEBUG
    int  count;
  #endif
  ERRORS_INITCHK_VAR
};

void  BigStack_init( char* mem, size_t mem_sizeof );
void  BigStack_start(void);
char* BigStack_alloc( unsigned int size );
void  BigStack_end(void);
#ifndef  ERRORS_CUT_DEBUG_TOOL
 void  BigStack_print(void);
#endif
void  BIGSTACK_CHECK(void);
void  BIGSTACK_DEBUG1(int* work);
void  BIGSTACK_DEBUG2(int* work);


/* ȉ͓p */
void  BigStack_init_imp( BigStack*, char* mem, size_t mem_sizeof );
void  BigStack_start_imp( BigStack* );
char*  BigStack_alloc_imp( BigStack*, unsigned int size );
void  BigStack_end_imp( BigStack* );
#ifndef  ERRORS_CUT_DEBUG_TOOL
 void  BigStack_print_imp( BigStack* );
#endif


#ifdef __cplusplus
}
#endif

#endif
 
/*--------------------------------------------------------------*/
/*<<< Mapping Area ---------------------------------------- >>> */ 
/*--------------------------------------------------------------*/

 
/**************************************************************************
*  <<< BigStack }`^XNΉ >>> 
*  <<< [BigStack_init, BigStack_start, BigStack_alloc, BigStack_end] >>>
*  <<< [BigStack_print] >>>
***************************************************************************/
#ifdef  USES_MULTASK
 #define  BigStack_init( mem, size ) \
   BigStack_init_imp( &BigStack_Sys_arr[MulTask_Sys_getCurIndex()], mem, size )
 #define  BigStack_start() \
   BigStack_start_imp( &BigStack_Sys_arr[MulTask_Sys_getCurIndex()] )
 #define  BigStack_alloc( size ) \
   BigStack_alloc_imp( &BigStack_Sys_arr[MulTask_Sys_getCurIndex()], size )
 #define  BigStack_end() \
   BigStack_end_imp( &BigStack_Sys_arr[MulTask_Sys_getCurIndex()] )
 #define  BigStack_print() \
   BigStack_print_imp( &BigStack_Sys_arr[MulTask_Sys_getCurIndex()] )
#else
 #define  BigStack_init( mem, size ) \
   BigStack_init_imp( &BigStack_Sys_arrX, mem, size )
 #define  BigStack_start() \
   BigStack_start_imp( &BigStack_Sys_arrX )
 #define  BigStack_alloc( size ) \
   BigStack_alloc_imp( &BigStack_Sys_arrX, size )
 #define  BigStack_end() \
   BigStack_end_imp( &BigStack_Sys_arrX )
 #define  BigStack_print() \
   BigStack_print_imp( &BigStack_Sys_arrX )
#endif


 
/**************************************************************************
*  <<< [BIGSTACK_CHECK] X^bNubN start - end Ή̃`FbN >>> 
*y⑫z
*EvOIOɌĂяo܂B
*Estart  end ̎s񐔂قȂ ASSERT Ɉ܂B
***************************************************************************/
#ifdef  NDEBUG
  #define  BIGSTACK_CHECK()
#else
  #ifdef  USES_MULTASK
    #define  BIGSTACK_CHECK() \
      if ( BigStack_Sys_arr[MulTask_Sys_getCurID()].block1 != NULL ) { \
        error2_0( BigStack_badStartEnd, \
        "BigStack_start  BigStack_end ̑Ή֌W" ); \
      }
  #else
    #define  BIGSTACK_CHECK() \
      if ( BigStack_Sys_arrX.block1 != NULL ) { \
        error2_0( BigStack_badStartEnd, \
        "BigStack_start  BigStack_end ̑Ή֌W" ); \
      }
  #endif
#endif

 
/**************************************************************************
*  <<< X^bNubN start - end Ή̃fobO >>> 
*  <<< [BIGSTACK_DEBUG1, BIGSTACK_DEBUG2, BIGSTACK_DEBUG3] >>>
*yz
*  Eint*  work;  [N̈i[Jϐ̃AhXwj
*y^z
*  void  BIGSTACK_DEBUG1(int* work);
*  void  BIGSTACK_DEBUG2(int* work);
*  void  BIGSTACK_DEBUG3(int* work);
*y⑫z
*EBIGSTACK_DEBUG1 ł̃X^bN|C^̈ʒu
*  BIGSTACK_DEBUG2 ܂ BIGSTACK_DEBUG3 ł̈ʒuƓǂ
*  `FbNăfobÕqg擾܂B
*Eُ킪 Errors_errPrintf Œʒm܂G[ɂ͂Ȃ܂B
*EBIGSTACK_DEBUG3 ́Aʉ߂Ƃ Errors_errPrintf Œʒm܂B
***************************************************************************/
#ifdef  ERRORS_CUT_DEBUG_TOOL
  #define  BIGSTACK_DEBUG1( work )  __cut_debug_tool
  #define  BIGSTACK_DEBUG2( work )  __cut_debug_tool
  #define  BIGSTACK_DEBUG3( work )  __cut_debug_tool
#else

 #ifdef  USES_MULTASK
  #define  BIGSTACK_DEBUG1( work ) \
    *(work) = BigStack_Sys_arr[MulTask_Sys_getCurIndex()].count
  #define  BIGSTACK_DEBUG2( work ) \
    if ( *(work) != BigStack_Sys_arr[MulTask_Sys_getCurIndex()].count ) \
      Errors_errPrintf( "BIGSTACK_DEBUG ERROR(%+d) in %s(%d)", \
        BigStack_Sys_arr[MulTask_Sys_getCurIndex()].count - *(work), \
        __FILE__, __LINE__ )
  #define  BIGSTACK_DEBUG3( work ) \
    if ( *(work) != BigStack_Sys_arr[MulTask_Sys_getCurIndex()].count ) \
      Errors_errPrintf( "BIGSTACK_DEBUG ERROR(%+d) in %s(%d)", \
        BigStack_Sys_arr[MulTask_Sys_getCurIndex()].count - *(work), \
        __FILE__, __LINE__ ); \
    else \
      Errors_errPrintf( "BIGSTACK_DEBUG through in %s(%d)", __FILE__, __LINE__ )
 #else
  #define  BIGSTACK_DEBUG1( work ) \
    *(work) = BigStack_Sys_arrX.count
  #define  BIGSTACK_DEBUG2( work ) \
    if ( *(work) != BigStack_Sys_arrX.count ) \
      Errors_errPrintf( "BIGSTACK_DEBUG ERROR(%+d) in %s(%d)", \
        BigStack_Sys_arrX.count - *(work), \
        __FILE__, __LINE__ )
  #define  BIGSTACK_DEBUG3( work ) \
    if ( *(work) != BigStack_Sys_arrX.count ) \
      Errors_errPrintf( "BIGSTACK_DEBUG ERROR(%+d) in %s(%d)", \
        BigStack_Sys_arrX.count - *(work), \
        __FILE__, __LINE__ ); \
    else \
      Errors_errPrintf( "BIGSTACK_DEBUG through in %s(%d)", __FILE__, __LINE__ )
 #endif

#endif

 
