/*************************************************************************
*  <<< \tgEFAOR (Except3) >>> 
**************************************************************************/

#include "mixer_precomp.h"  /* Auto precompiled header, Look at mixer-... folder */
// #pragma hdrstop ("mixer_precomp")

#define  STDLIBS_INCLUDE
#define  STDLIBS_INCLUDE_SETJMP_H
#define  STDLIBS_INCLUDE_STRING_H

#if defined(USES_MXP_AUTOINC)
 #include "except3.ah"  /* Auto include header, Look at mixer-... folder */
#endif


#ifdef  USES_MULTASK
  Except3  Except3_con[Except3_m];
#else
  Except3  Except3_con;
#endif

#if !defined(NDEBUG) || defined(ERRORS_ERROR_REPORT)
 static char*  Except3_OutOfTry_Str = "Lb`łȂO܂";
#else
 static char*  Except3_OutOfTry_Str = "";
#endif

static char*  Except3_DupTry_Str = "catch  finally ubNAOWvȂ̈"
  "OĂȂƂ try Ă͂Ȃ܂B\n"
  "ȑÕG[bZ[Wꕔ\܂B";
static char*  Except3_FinallyThrow_Str = "finally ubNŗO܂B"
  "ꕔ̌n͍s܂B";
static char*  Except3_TryStackOver_Str = "try pX^bN̈悪ςɂȂ܂B";

 
/*--------------------------------------------------------------------*/
/* <<<(Except3) OVXe >>> */ 
/*--------------------------------------------------------------------*/
 
/*************************************************************************
*  <<< [Except3_init_imp] Except3_init ̎ >>> 
**************************************************************************/
void  Except3_init_imp( Except3* m,
  Except3_Try* tryInfo, int tryInfo_size )
{
  ERRORS_INITCHK( m, 0 );

  m->bExcept = false;
  m->bNoJumpArea = false;
  m->tryInfo = tryInfo;
  m->mTry = tryInfo_size / sizeof(Except3_Try);
}


 
/*************************************************************************
*  <<< [Except3_try_imp] try ̎ >>> 
**************************************************************************/
void  Except3_try_imp( Except3* m, char* file, int line )
{
  EXCEPT3_INITCHK( m );

  #ifndef  NDEBUG
    if ( m->bExcept )
      Except3_error( Except3_Err_DupTry, Except3_DupTry_Str );
    if ( m->nTry >= m->mTry - 1 )  /* -1 ̓}NŊɎgĂ邽 */
      Except3_error( Except3_Err_TryStackOver, Except3_TryStackOver_Str );
  #endif

  /* try lXg̋L^ */
  m->tryInfo[m->nTry].file = file;
  m->tryInfo[m->nTry].line = line;
  m->tryInfo[m->nTry].bNoJumpAreaTop = m->bNoJumpArea;

  /* try  */
  m->nTry ++;
  m->bExcept = false;
  m->bAgain = false;
  m->bCatch = false;
  m->bNoJumpArea = false;
}


 
/*************************************************************************
*  <<< [Except3_catch_imp] catch ̎ >>> 
**************************************************************************/
int  Except3_catch_imp( Except3* m )
{
  extern int  Errors_errDupCount;
  EXCEPT3_INITCHK( m );

  if ( m->bAgain )  return  0;  /* catch ̍ăX[ */

  Errors_errDupCount = 0;
  m->bCatch = true;
  return  1;
}


 
/*************************************************************************
*  <<< [Except3_end_finally_imp] >>> 
**************************************************************************/
void  Except3_end_finally_imp( Except3* m )
{
  EXCEPT3_INITCHK( m );

  if ( m->tryInfo[m->nTry - 1].bNoJumpAreaTop )
    m->bNoJumpArea = true;

  if ( m->bExcept ) {
    if ( m->bAgain ) {
      m->nTry --;
      m->bAgain = false;
      m->bCatch = false;
      if ( m->nTry <= 0 ) {
        if ( ! m->tryInfo[0].bNoJumpAreaTop )
          Except3_error( Except3_Err_OutOfTry, Except3_OutOfTry_Str );
      }
      else {
        if ( ! m->tryInfo[m->nTry].bNoJumpAreaTop )
          longjmp( m->tryInfo[m->nTry - 1].longjmp_buf, 1 );
      }
    }
    else if ( ! m->bCatch ) {
      m->nTry --;
      if ( m->nTry <= 0 ) {
        if ( ! m->tryInfo[0].bNoJumpAreaTop )
          Except3_error( Except3_Err_OutOfTry, Except3_OutOfTry_Str );
      }
      else {
        if ( ! m->tryInfo[m->nTry].bNoJumpAreaTop )
          longjmp( m->tryInfo[m->nTry - 1].longjmp_buf, 1 );
      }
    }
    else {
      m->nTry --;
      m->bExcept = false;
      m->bCatch = false;
      Errors_clearError();
    }
  }
  else {
    if ( m->nTry <= 0 )
      Except3_error( Except3_Err_OutOfTry, Except3_OutOfTry_Str );
    m->nTry --;
  }
}


 
/*************************************************************************
*  <<< [Except3_throw_imp] throw ̎ >>> 
**************************************************************************/
void  Except3_throw_imp( Except3* m, void* msg )
{
  #ifndef  NDEBUG
    static  int  throwing = 0;

    throwing ++;
    ASSERT( throwing == 1 );

    EXCEPT3_INITCHK( m );
    if ( m->bExcept && ! m->bCatch )
      Except3_error( Except3_Err_FinallyThrow, Except3_FinallyThrow_Str );
  #endif

  ERRORS_FUNCLOG_ONLONGJUMP();

  /* ObZ[Wo^ */
  m->msg = msg;

  /* OWv */
  /* ʏ̃X[́Aʂ catch ցAcatch ł̍ăX[ ͓ʂ finally  */
  if ( m->bNoJumpArea ) {
    m->bExcept = true;
    #ifndef  NDEBUG
      throwing = 0;
    #endif
  }
  else {
    if ( m->nTry <= 0 )
      Except3_error( Except3_Err_OutOfTry, Except3_OutOfTry_Str );

    if ( m->bCatch ) {
      m->bAgain = true;
      #ifndef  NDEBUG
        throwing = 0;
      #endif
      longjmp( m->tryInfo[m->nTry - 1].longjmp_buf, 1 );
    }
    else {
      m->bExcept = true;
      #ifndef  NDEBUG
        throwing = 0;
      #endif
      longjmp( m->tryInfo[m->nTry - 1].longjmp_buf, 1 );
    }
  }
}


 
/*************************************************************************
*  <<< [Except3_startNoJumpArea_imp] Except3_startNoJumpArea ̎ >>> 
**************************************************************************/
void  Except3_startNoJumpArea_imp( Except3* m )
{
  m->bNoJumpArea = true;
}
 
/*************************************************************************
*  <<< [Except3_endNoJumpArea_imp] Except3_endNoJumpArea ̎ >>> 
**************************************************************************/
void  Except3_endNoJumpArea_imp( Except3* m )
{
  m->bNoJumpArea = false;

  if ( m->bExcept ) {
    if ( m->nTry <= 0 )
      Except3_error( Except3_Err_OutOfTry, Except3_OutOfTry_Str );

    if ( m->bCatch ) {
      m->bAgain = true;
      longjmp( m->tryInfo[m->nTry - 1].longjmp_buf, 1 );
    }
    else {
      m->bExcept = true;
      longjmp( m->tryInfo[m->nTry - 1].longjmp_buf, 1 );
    }
  }
}

 
/*************************************************************************
*  <<< [Except3_isNoJumpArea_imp] Except3_isNoJumpArea ̎ >>> 
**************************************************************************/
bool  Except3_isNoJumpArea_imp( Except3* m )
{
  return  ( m->bNoJumpArea == true || m->nTry == 0 );
}

 
/*************************************************************************
*  <<< [Except3_isError_imp] Except3_isError ̎ >>> 
**************************************************************************/
bool  Except3_isError_imp( Except3* m )
{
  EXCEPT3_INITCHK( m );

  /* dOǂL^ */
  if ( m->bExcept )  return  true;
  return  false;
}


 
/*************************************************************************
*  <<< [Except3_print_imp] OVXȅԂfobO\ >>> 
**************************************************************************/
#ifndef  ERRORS_CUT_DEBUG_TOOL
#ifdef  USES_MULTASK
  void  Except3_print_imp( Except3* m, int id )
#else
  void  Except3_print_imp( Except3* m )
#endif
{
  int  i;

  EXCEPT3_INITCHK( m );

  #ifdef  USES_MULTASK
    Errors_printf( "Except3[%d]: adr = %p", id, m->msg );
  #else
    Errors_printf( "Except3:" );
  #endif
  Errors_printf( "  msg adr = %p", m->msg );
  Errors_printf( "  bExcept = %d", m->bExcept );
  Errors_printf( "  bCatch = %d", m->bCatch );
  Errors_printf( "  bAgain = %d", m->bAgain );
  Errors_printf( "  nTry = %d", m->nTry );
  #ifdef  EXCEPT3_NO_HINT
    Errors_printf( "  try is NO HINT" );
  #else
    for ( i = 0; i < m->nTry; i++ ) {
      Errors_printf( "  try[%d] in  %s:%d",
        i, m->tryInfo[i].file, m->tryInfo[i].line );
    }
  #endif
}
#endif
 
/*************************************************************************
*  <<< [Except3_error_imp] OVXëُI >>> 
*  <<< [Except3_bNoExitChk] ُIɃ`FbNȂtO >>>
**************************************************************************/
void  Except3_error_imp( int code, const char* msg, char* file, int line )
{
  #ifdef  USES_MULTASK
    Except3*  m = &Except3_con[MulTask_Sys_getCurIndex()];
  #else
    Except3*  m = &Except3_con;
  #endif

  if ( Errors_MsgPool_isInit( Errors_MsgPool_getGlobl() ) &&
       Errors_Msg_getGlobl()->code != Errors_NoError ) {
    Errors_MsgPool_add( Errors_MsgPool_getGlobl(), Errors_Msg_getGlobl() );
    /* ̏ŃnOAbvƂ́AErrors_MsgPool ̃̈悪 */
    /* [Jϐ̃XR[vOɂȂȂǂ̖ɂȂĂ\܂B */
  }
  Errors_Msg_init( Errors_Msg_getGlobl(), -1, code, file, line, "%s", msg );

  if ( Errors_hdl != NULL ) {
    extern  Errors_errDupCount;
    Errors_errDupCount ++;

    m->bExcept = false;
    (*Errors_hdl)( Errors_Msg_getGlobl()->id, code, Errors_Msg_getGlobl()->msg );
  }
  else
    Errors_printf_release( Errors_Msg_getGlobl()->msg );

  Errors_exit( file, line );
}
 
/*--------------------------------------------------------------------*/
/* <<<(Except3_MsgMng) G[bZ[W̊Ǘ >>> */ 
/*--------------------------------------------------------------------*/
 
/*************************************************************************
*  <<< (Except3_MsgStack) bZ[WEX^bNی^ >>> 
**************************************************************************/
#ifdef  USES_INF
#ifndef  NDEBUG
INF_FUNC_R1( Except3_MsgStack,push, void*, Except3_MsgStack_push, Except3_MsgStack,void*, t,a )
INF_FUNC_R1( Except3_MsgStack,pop,  void*, Except3_MsgStack_pop, Except3_MsgStack,void*, t,a )
#endif
#endif

 
