/**************************************************************************
*  <<< t@C̊g (FileX) >>> 
***************************************************************************/

#ifndef __FILEX_H
#define __FILEX_H

#if !defined(FOR_STDLIB) && !defined(USES_STDLIBS)
#error  need Standard Library
#endif
#include  <stdio.h>
#ifndef  FOR_WINCE
 #include  <time.h>
 #include  <io.h>
#endif



 
/*************************************************************************
*  <<< W[ݒEDwb_ >>> 
**************************************************************************/
#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#ifndef  USES_FILEX
#define  USES_FILEX


/* fBXNeʕs̃V~[VA#define Ȃ΃V~[gȂ */
/* FileX_FreeSpc_scan ֐Q */
/*#define  FILEX_FREESIZE*/

typedef  struct _FileX_UniRead  FileX_UniRead;
typedef  struct _FileX_UniWrite FileX_UniWrite;
typedef  struct _FileX_CurDir   FileX_CurDir;
typedef  struct _FileX_FreeSpc  FileX_FreeSpc;


/*  <<< [FileX_CallBack] Rs[̐i󋵕\̂߂̃R[obN֐̌^ >>> */
/*typedef  void  (*FileX_CopyBack)( void*, int now, int all );*/
#ifdef __cplusplus
extern "C" {
#endif
typedef  void  (*FileX_CallBack)( void*, int now, int all );
#ifdef __cplusplus
}
#endif


#define  STDLIBS_INCLUDE_LIMITS_H


#endif  /* USES_FILEX */


/*[END_OF_PRIORITY_HEADER]*/
#endif /* USES_PRIORITY_HEADER */
 
/*************************************************************************
*  <<< G[R[h >>> 
**************************************************************************/
#define  FileX_Err_EOF  (361)              /* [Compone_GID:Errors_Code] */
#define  FileX_Err_CannotWriteOpen  (362)  /* [Compone_GID:Errors_Code] */
#define  FileX_Err_CannotReadOpen   (363)  /* [Compone_GID:Errors_Code] */
#define  FileX_Err_NotFindCopySrc   (364)  /* [Compone_GID:Errors_Code] */
#define  FileX_Err_CannotWrite      (365)  /* [Compone_GID:Errors_Code] */
#define  FileX_Err_CannotMkdir      (366)  /* [Compone_GID:Errors_Code] */
#define  FileX_Err_AccessDenied     (367)  /* [Compone_GID:Errors_Code] */
#define  FileX_Err_NotUnicodeFile   (368)  /* [Compone_GID:Errors_Code] */
 
/*-------------------------------------------------------------------*/
/* <<< Interface Area ------------------------------------------ >>> */ 
/*-------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

 
/*************************************************************************
*  <<< [FileX] t@C >>> 
**************************************************************************/
FILE* FileX_open( const char* path, const char* mode );
char* FileX_getOpenedFName( FILE* fp );
void  FileX_getCSV( FILE* file, char* data, int data_maxLen );
void  FileX_skipCSV( FILE* file );
void  FileX_putCSV( FILE* file, char* data );

bool  FileX_isExist( const char* path );
bool  FileX_isDir( const char* path );
int   FileX_getOneExistWild( const char* wild_path, char* first_path );
void  FileX_getUpdate( const char* path, time_t* date );
void  FileX_setUpdate( const char* path, time_t* date );
int   FileX_getSize( const char* path );
int   FileX_getSftSum( const char* path, int maxFileSize );
#if  defined(USES_FILEFIND) && defined(USES_STRX)
void  FileX_getPathes( const char* folder, StrX_Mem* files );
#endif
int   FileX_cmpTime( const char* pathA, const char* pathB );
void  FileX_getTmpPath( const char* prefix, char* path );
void  FileX_getTmpPath2( const char* prefix, const char* folder, char* path );
void  FileX_getTmpPath3( const char* folder, const char* prefix, const char* ext, char* path );

int   FileX_isDiff( const char* fNameA, const char* fNameB );
#ifdef  USES_STDPLUS
void  FileX_copy( const char* to_path, const char* from_path );
void  FileX_copy2( const char* to_path, const char* from_path,
  FileX_CallBack callback, void* obj );
void  FileX_move( const char* to_path, const char* from_path );
int   FileX_copyPickup( const char* to_path, const char* from_path,
  int startPos, int endPos );
int   FileX_copyPickup2( const char* to_path, const char* from_path,
  int startPos, int endPos, FileX_CallBack callback, void* obj );
void  FileX_outPart( FILE* out, FILE* in, int in_start, int in_over );

#endif
#ifdef  USES_STRX
#ifdef  USES_STDPLUS
#ifdef  USES_FILEFIND
void  FileX_copyFolder( const char* to_path, const char* from_path,
  bool bSub );
#endif
#endif
#endif
#ifdef  USES_NESTFIND
void  FileX_removeFolder( const char* path );
#endif
void  FileX_setReadOnly( const char* path, bool bReadOnly );

void  FileX_cat( const char* to_path, const char* from_path );
void  FileX_include( FILE* to, const char* from_path, int mode );
#ifdef USES_STRX
#ifdef USES_BIGSTACK
void  FileX_mkdir2( const char* path, int bFile );
#endif
#endif
void  FileX_backup( const char* path );
void  FileX_restoreIfSame( const char* path );
void  FileX_toBackupPath( char* path );
void  FileX_write( const char* path, const char* flag, void* data, int size );
int   FileX_read0( const char* path, const char* flag, void* data, int size );

extern bool  FileX_bCopyFailed;  /*  FileX_copy(), ݂ɎsƂ邩ǂ */
 
/*************************************************************************
*  <<< [FileX_UniRead] UNICODE t@C Shift-JIS ƂēǂݍރtB^ >>> 
**************************************************************************/
#if  defined(FOR_WIN32) || defined(FOR_DOS32)
char*  FileX_UniRead_init( FileX_UniRead* m, const char* path );
void   FileX_UniRead_finish( FileX_UniRead* m );
bool   FileX_UniRead_isUniFile( FileX_UniRead* m );

void   FileX_copyUni2SJis( const char* toSjisPath, const char* fromUniPath );
bool   FileX_isUnicodeFIle( const char* path );

struct _FileX_UniRead {
  char  tmp_path[_MAX_PATH];

  ERRORS_INITCHK_VAR
};
#endif

 
/*************************************************************************
*  <<< [FileX_UniWrite] Shift-JIS `ŏ UNICODE t@CtB^ >>> 
**************************************************************************/
#if  defined(FOR_WIN32) || defined(FOR_DOS32)
char*  FileX_UniWrite_init( FileX_UniWrite* m, const char* path );
void   FileX_UniWrite_finish( FileX_UniWrite* m );
void   FileX_copySJis2Uni( const char* toUniPath, const char* fromSJisPath );

struct _FileX_UniWrite {
  char  path[_MAX_PATH];
  char  tmp_path[_MAX_PATH];

  ERRORS_INITCHK_VAR
};
#endif
 
/*************************************************************************
*  <<< [FileX_CurDir] JgtH_EX^bN >>> 
**************************************************************************/
#ifdef USES_BIGSTACK
struct _FileX_CurDir {
  char*  curPath;  /* ܂ł̃JgtH_̐΃pX */
};
void  FileX_CurDir_init( FileX_CurDir*, const char* path );
void  FileX_CurDir_finish( FileX_CurDir* );
#endif

#define FileX_fname_max  256



 
/*************************************************************************
*  <<< [FileX_FreeSpc] fBXN̋󂫗e >>> 
**************************************************************************/
struct _FileX_FreeSpc {
  unsigned long  sectorsPerCluster;
  unsigned long  bytesPerSector;
  unsigned long  numberOfFreeClusters;
  unsigned long  totalNumberOfClusters;
};

void  FileX_FreeSpc_init( FileX_FreeSpc* );
void  FileX_FreeSpc_scan( FileX_FreeSpc*, const char* root_path );
int   FileX_FreeSpc_getFreeSize( FileX_FreeSpc* );
int   FileX_FreeSpc_getTotalSize( FileX_FreeSpc* );
int   FileX_FreeSpc_getUseFileSize( FileX_FreeSpc*, const char* path );
int   FileX_FreeSpc_culcNCluster( FileX_FreeSpc*, int size );

#define  FILEX_TO_LAST    -1
#define  FILEX_TO_FULL    -2

#ifdef  FILEX_FREESIZE
  extern  FileX_FreeSpc  FileX_freeSpcSym;
#endif
 
#ifdef __cplusplus
}
#endif

/*-------------------------------------------------------------------*/
/* <<< Mapping Area -------------------------------------------- >>> */ 
/*-------------------------------------------------------------------*/


 
/***********************************************************************
  <<< [FileX_UniRead_isUniFile] UNICODE t@CǂԂ >>> 
y⑫z
Ebool   FileX_UniRead_isUniFile( FileX_UniRead* m );
************************************************************************/
#define  FileX_UniRead_isUniFile( m ) \
  ( (m)->m_tmp_path[0] != '\0' )

 
#endif /* __FILEX_H */ 
 
