/***********************************************************************
*  <<< t@C (IniFile) >>> 
* yg\z
* ERg邱ƁiɊւĂ̂ Windows Ƃ̌݊lȂj
* E[URgȂ
************************************************************************/

#include "mixer_precomp.h"  /* Auto precompiled header, Look at mixer-... folder */
// #pragma hdrstop

#ifdef  USES_MXP_AUTOINC
 #include  <inifile.ah>  /* Auto include header, Look at mixer-... folder */
#endif

char* IniFile_Write_componeName = "IniFile_Write";
char* IniFile_Read_componeName = "IniFile_Read";


 
/*---------------------------------------------------------*/
/* <<<t@CE݃c[ [IniFile_Write] >>> */ 
/*---------------------------------------------------------*/


 
/***********************************************************************
*  <<< [IniFile_Write_init] Et@CJ >>> 
************************************************************************/
void  IniFile_Write_init( IniFile_Write* m, const char* fname )
{
  ERRORS_FINISHCHK_FOR_INIT( IniFile_Write_finish );

  m->file = fopen( fname, "wt" );
  if ( m->file == NULL ) {
    error2_1( FileX_Err_CannotWriteOpen,
      "݃[h open ł܂B%s", fname );
  }
  m->firstSection = true;
}


 
/***********************************************************************
*  <<< [IniFile_Write_finish] nEt@C >>> 
************************************************************************/
void  IniFile_Write_finish( IniFile_Write* m )
{
  ERRORS_FINISHCHK_FOR_FINISH( IniFile_Write_finish );

  fputs( " \n", m->file );
  fclose( m->file );
}


 
/***********************************************************************
*  <<< [IniFile_Write_putSection] ZNVo͂ >>> 
************************************************************************/
void  IniFile_Write_putSection( IniFile_Write* m, const char* section )
{
  if ( ! m->firstSection )
    fputs( " \n", m->file );
  m->firstSection = false;
  fprintf( m->file, "[%s] \n", section );
}


 
/***********************************************************************
*  <<< [IniFile_Write_putVar] lo͂ >>> 
*yz
*  Echar*  attr_name;  
*  Echar*  types;      ^Xg
*  E...                ̒lׂ
*y⑫z
*Etypes ɂ́Aȉ̌^w蕶ׂw肵܂B
*    E's'  ^
*    E'i'  ^iint^j
*    E'b'  _^ibool^j
*    E'x'  ^16iiint^j
*    E't'  ^itime_t*^j
*    E'-'  l𖳎ii[ϐw肵Ȃj
*yz
*Eattr = 1, string, 2  Ƃlo͂ꍇA
*  printf ƓlɁAȉ̂悤ɋLq܂B
*   IniFile_Write_putVar( file, "attr", "isi", 1, "string", 2 );
************************************************************************/
void  IniFile_Write_putVar( IniFile_Write* m, const char* attr_name,
  const char* types, ... )
{
  static char  s[4096];
  va_list  va;

  fprintf( m->file, "%s = ", attr_name );

  va_start( va, types );

  if ( *types != '\0' ) {
    for (;;) {
      switch ( *types ) {
        case  's':
          StrX_toCSV( s, va_arg( va, char* ), sizeof(s) );
          fputs( s, m->file );
          break;
        case  'i':
          fprintf( m->file, "%d", va_arg(va, int) );
          break;
        case  'b':
		  fprintf( m->file, "%c", ( va_arg(va, bool) ? '1' : '0' ) );
          break;
        case  'x':
          fprintf( m->file, "0x%X", va_arg(va, int) );
          break;
        case  't':
          #ifdef USES_TIMEDATE
            ASSERT( sizeof(s) >= TimeDate_loadBuf_size );
            TimeDate_saveStr( va_arg(va, time_t*), s );
            fputs( s, m->file );
            break;
          #endif
        default:
          ASSERT( *types == '-' );
          break;
      }

      types ++;
      if ( *types == '\0' )
        break;

      fputs( ", ", m->file );
    }
  }

  va_end( va );

  fputs( "\n", m->file );
}


 
/***********************************************************************
*  <<< [IniFile_Write_putLabel] xo͂ >>> 
*yz
*  Echar*  label;  x
*y⑫z
*Et@Cɂ́Ax̒ ':' t܂B
*Eo͂x́AIniFile_Read_getVar ֐găXLbv
*  Kv܂B̍ہA^Xg "" ɂ܂B
************************************************************************/
void  IniFile_Write_putLabel( IniFile_Write* m, const char* label )
{
  fprintf( m->file, "%s:\n", label );
}


 
/***********************************************************************
*  <<< [IniFile_Write_putMultiLine] so͂ >>> 
*yz
*  Echar*  attr_name;  
*  Echar*  retStr;     si"\r\n""\n"j
*  Echar*  s;          s̕
*y⑫z
*Et@Cɂ́Aȉ̂悤ɓт܂B
*  attr = text of line 1
*  attr = text of line 2
*  attr = text of line 3
************************************************************************/
#ifdef  USES_STRX
void  IniFile_Write_putMultiLine( IniFile_Write* m, const char* attr_name,
  const char* retStr, const char* s )
{
  enum { data_size = 256 };
  char*  r;
  char   data[data_size];

  for (;;) {
    r = strstr( s, retStr );
    if ( r != NULL ) {
      *(char*)r = '\0';
      StrX_toCSV( data, s, data_size - 1 );
      fprintf( m->file, "%s = %s\n", attr_name, data );
      *(char*)r = *retStr;
      s = r + strlen( retStr );
    }
    else {
      if ( ! StrX_isSpaceStr( s ) ) {
        StrX_toCSV( data, s, data_size - 1 );
        fprintf( m->file, "%s = %s\n", attr_name, data );
      }
      return;
    }
  }
}
#endif

 
/**************************************************************************
*  <<< [IniFile_Write_putTypeInfo] t@C̃o[Wǂ݂Ń`FbN >>> 
*y⑫z
*EIniFile_Read_checkTypeInfo Ńf[^`FbNł܂B
***************************************************************************/
void  IniFile_Write_putTypeInfo( IniFile_Write* m, const char* appName,
  int verNum )
{
  IniFile_Write_putVar( m, "Application", "s", appName );
  IniFile_Write_putVar( m, "Version", "i", verNum );
}
 
/***********************************************************************
*  <<< [IniFile_Write_putMultiStrV] ̕𕡐sŏo͂ >>> 
*yz
*  Echar*  attr_name;  
*  EStrV_Set*  strs;   ̕
*y⑫z
*Et@Cɂ́Aȉ̂悤ɓт܂B
*  attr = string of number 1
*  attr = string of number 2
*  attr = string of number 3
************************************************************************/
#ifdef  USES_STRV
void  IniFile_Write_putMultiStrV( IniFile_Write* m, const char* attr_name,
  StrV_Set* strs )
{
  StrV_SetP  sp;

  for ( StrV_Set_forEach( strs, &sp ) ) {
    fprintf( m->file, "%s = %s\n", attr_name, sp.p );
  }
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Write_putMultiStrVM] ̕𕡐sŏo͂ >>> 
*yz
*  Echar*  attr_name;  
*  EStrV_Mem*  strs;   ̕
*y⑫z
*Et@Cɂ́Aȉ̂悤ɓт܂B
*  attr = string of number 1
*  attr = string of number 2
*  attr = string of number 3
************************************************************************/
#ifdef  USES_STRV
void  IniFile_Write_putMultiStrVM( IniFile_Write* m, const char* attr_name,
  StrV_Mem* strs )
{
  StrV_SetP  sp;

  for ( StrV_Mem_forEach( strs, &sp ) ) {
    fprintf( m->file, "%s = %s\n", attr_name, sp.p );
  }
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Write_putMultiStrAV] ̕𕡐sŏo͂ >>> 
*yz
*  Echar*  attr_name;  
*  EArrX_Able*  strs;  ̕ivf StrV_AbleElem ^j
*y⑫z
*Et@Cɂ́Aȉ̂悤ɓт܂B
*  attr = string of number 1
*  attr = string of number 2
*  attr = string of number 3
************************************************************************/
#ifdef  USES_STRV
void  IniFile_Write_putMultiStrAV( IniFile_Write* m, const char* attr_name,
  ArrX_Able* strs )
{
  StrV_AbleElem*  sv;

  for ( ArrX_Able_forEach( strs, &sv, StrV_AbleElem ) ) {
    fprintf( m->file, "%s = %s\n", attr_name, sv->s );
  }
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Write_putPathes] t@CpX̏Wo͂ >>> 
*yz
*  Echar*  section_name;  ZNV
*  Echar** pathes;        t@CpX̏W̐擪AhX
*  Eint    nPath;         t@CpX̐
*y⑫z
*Et@CpX̏ẂAP̃ZNVL܂B
*Ȅo͂́AZNV̏o͂n߂ĂB
*yz
*Eo͂f[^́AIniFile_Read_getPathes ֐͂邱Ƃł܂B
************************************************************************/
void  IniFile_Write_putPathes( IniFile_Write* m, const char* section_name,
  char** pathes, int nPath )
{
  int  i;
  static char  prevFolder[_MAX_PATH];
  static char  s[_MAX_PATH];

  IniFile_Write_putSection( m, section_name );

  for ( i = 0; i < nPath; i++ ) {

    /* tH_EpXo͂ */
    ASSERT( strlen( *pathes ) < _MAX_PATH );
    strcpy( s, *pathes );
    StrX_cutFName( s );
    if ( s[0] == '\0' )  strcpy( s, "." );
    if ( i == 0 || strcmp( s, prevFolder ) != 0 ) {
      IniFile_Write_putVar( m, "Folder", "s", s );
      strcpy( prevFolder, s );
    }

    /* t@Co͂ */
    StrX_cpyFName( s, *pathes );
    IniFile_Write_putVar( m, "File", "s", s );

    pathes ++;
  }
}


 
/*---------------------------------------------------------*/
/* <<<t@CEǂݍ݃c[ [IniFile_Read] >>>  */ 
/*---------------------------------------------------------*/



 
/***********************************************************************
*  <<< [IniFile_Read_init] Et@CJ >>> 
************************************************************************/
void  IniFile_Read_init( IniFile_Read* m, const char* fname,
  char* lineBuf, int lineBuf_sizeof )
{
  m->file = FileX_open( fname, "rt" );
  if ( m->file == NULL ) {
    error2_1( FileX_Err_CannotReadOpen,
      "ǂ݂݃[h open ł܂B%s", fname );
  }
  m->lineBuf = lineBuf;
  m->lineBuf_sizeof = lineBuf_sizeof;
  m->string_sizeof = 256;
  strcpy( m->path, fname );

  ERRORS_FINISHCHK_FOR_INIT( IniFile_Read_finish );
}


 
/***********************************************************************
*  <<< [IniFile_Read_setStringSize] ǂݍނƂ̍őTCY >>> 
*y@\z
*EIniFile_Read_getVar ŕ^ǂݍނƂɎw肷obt@
*  TCYw肵܂B
************************************************************************/
void  IniFile_Read_setStringSize( IniFile_Read* m, int size )
{
  m->string_sizeof = size;
}


 
/***********************************************************************
*  <<< [IniFile_Read_finish] nEt@C >>> 
************************************************************************/
void  IniFile_Read_finish( IniFile_Read* m )
{
  ERRORS_FINISHCHK_FOR_FINISH( IniFile_Read_finish );

  fclose( m->file );
}


 
/***********************************************************************
*  <<< [IniFile_Read_setSection] ZNVI >>> 
*y⑫z
*ẼZNVw̖OƈقȂƂ́AIniFile_NotFoundSection G[
*  ɂȂ܂B
*Et@C̍Ō܂œǂ񂾂 FileX_Err_EOF G[ɂȂ܂B
************************************************************************/
void  IniFile_Read_setSection( IniFile_Read* m, const char* section )
{
  char*  buf = m->lineBuf;
  char*  p;
  long   pos = ftell( m->file );

  /* s΂āAZNVǂݍ */
  do {
    fgets( buf, m->lineBuf_sizeof, m->file );
    StrX_trim( buf );

    if ( feof( m->file ) ) {
      error2_2( FileX_Err_EOF, "EOF in IniFile_Read_setSection %s [%s]",
        m->path, section );
    }
  } while ( buf[0] == '\0' );

  /* tH[}bg̃`FbN */
  p = strchr( buf, ']' );
  if ( buf[0] != '[' || p == NULL ) {
    error2_2( IniFile_Err_BadFormat,
      "tH[}bg in IniFile_Read_setSection %s [%s]",
      m->path, section );
  }
  *p = '\0';

  /* ZNṼ`FbN */
  if ( stricmp( section, buf + 1 ) != 0 ) {
    fseek( m->file, pos, SEEK_SET );
    error2_2( IniFile_NotFoundSection,
      "ZNV҂̂ƈقȂ %s [%s]", m->path, section );
  }
}


 
/***********************************************************************
*  <<< [IniFile_Read_reset] t@C|C^擪ɖ߂ >>> 
*y⑫z
*Esection ɈvZNVꍇ IniFile_NotFoundSection G[
*  ɂȂAt@C|C^͖Ɉړ܂B
************************************************************************/
void  IniFile_Read_reset( IniFile_Read* m )
{
  rewind( m->file );
}


 
/***********************************************************************
*  <<< [IniFile_Read_searchSection] ZNV >>> 
*yz
*  Echar* section;   ZNV
*  Ebool  upward;    ɂ邩ǂ
*  Elong  Ԃl;    ZNV̐擪̑̃t@CAhX
*y⑫z
*Esection ɈvZNVꍇ IniFile_NotFoundSection G[
*  ɂȂAt@C|C^͖Ɉړ܂B
************************************************************************/
long  IniFile_Read_searchSection( IniFile_Read* m, const char* section,
  bool upward )
{
  char*  buf = m->lineBuf;
  char*  p;
  int  eof_count = 0;

  for (;;) {

    /* Psǂݍ */
    fgets( buf, m->lineBuf_sizeof, m->file );
    if ( buf[strlen(buf)-1] == '\n' )
      buf[strlen(buf)-1] = '\0';

    /* Pڂ EOF ȂAt@C̐擪ցAQڂȂO */
    if ( feof( m->file ) ) {
      eof_count ++;
      if ( eof_count >= 2 || ! upward ) {
        error2_1( IniFile_NotFoundSection,
          "ZNV %s ܂", section );
      }
      rewind( m->file );
    }

    /* ZNVv邩肷 */
    if ( buf[0] == '[' ) {
      p = strchr( buf, ']' );
      if ( p != NULL ) {
        *p = '\0';
        if ( strcmp( section, buf + 1 ) == 0 )
          return  ftell( m->file );
      }
    }
  }
}


 
/***********************************************************************
*  <<< [IniFile_Read_searchSection2] ꑮvZNV >>> 
*yz
*  Echar*  section;  ZNV
*  Echar*  attr;     ꑮ
*  Echar*  type;     ꑮ̃^Cv
*  E...              ꑮ̒lƔrl
*  Elong  Ԃl;    ZNV̐擪̑̃t@CAhX
************************************************************************/
#ifdef   USES_BIGSTACK
void  IniFile_Read_searchSection2( IniFile_Read* m, const char* section,
  const char* attr, const char* type, ... )
{
  void*  var;
  va_list  va;
  void*  p;
  int  i;
  bool b;

  BigStack_start();
  c_try {
    switch ( *type ) {
      case 's':
        var = BigStack_alloc( m->string_sizeof  + 1 );
        va_start( va, type );
        p = va_arg( va, void* );
        va_end( va );
        do {
          IniFile_Read_searchSection( m, section, true );
          IniFile_Read_getVar( m, attr, type, var );
        } while ( strcmp( var, p ) != 0 );
        break;
      case 'i':
        var = BigStack_alloc( sizeof(int) );
        va_start( va, type );
        i = va_arg( va, int );
        va_end( va );
        do {
          IniFile_Read_searchSection( m, section, true );
          IniFile_Read_getVar( m, attr, type, var );
        } while ( *(int*)var != i );
        break;
      case 'b':
        var = BigStack_alloc( sizeof(bool) );
        va_start( va, type );
        b = va_arg( va, bool );
        va_end( va );
        do {
          IniFile_Read_searchSection( m, section, true );
          IniFile_Read_getVar( m, attr, type, var );
        } while ( *(bool*)var != b );
        break;
    }
  }
  c_finally {
    BigStack_end();
  } c_end_finally;
}
#endif   /* USES_BIGSTACK */



 
/* <<< -------- l̓ -------- >>> */ 


 
/***********************************************************************
*  <<< [IniFile_Read_getCount] ̐𐔂 >>> 
************************************************************************/
int  IniFile_Read_getCount( IniFile_Read* m, const char* attr_name )
{
  int  count = 0;
  long  pos;
  char*  buf = m->lineBuf;
  char*  p;
  char   c;

  pos = ftell( m->file );

  for (;;) {
    if ( fgets( buf, m->lineBuf_sizeof, m->file ) == NULL )  break;
    while ( *buf == ' ' || *buf == '\t' ) {
      if ( *buf == '\0' )  break;
      buf++;
    }
    p = &buf[strlen(attr_name)];
    c = *p;
    if ( c != ' ' && c != '=' && c != ':' )  break;
    *p = '\0';
    if ( stricmp( buf, attr_name ) != 0 )  break;
    count ++;
  }

  fseek( m->file, pos, SEEK_SET );
  return  count;
}


 
/***********************************************************************
*  <<< [IniFile_Read_getVar] l͂ >>> 
*yz
*  Echar*  attr_name;  
*  Echar*  types;      ^Xg
*  E...                ̒li[AhXׂ
*  Elong  Ԃl;      ̑s̐擪̃t@CAhX
*y⑫z
*Etypes ɂ́Aȉ̌^w蕶ׂw肵܂B
*    E's'or'S'  ^ichar*^Ǎ^ char*j
*    E'i'       ^iint^Ǎ^ int*j
*    E'b'       _^ibool^Ǎ^ bool*j
*    E't'       ^itime_t*^Ǎ^ time_t*j
*    E'-'       l𖳎ii[ϐw肵Ȃj
*EĂƁAO𓊂܂B
*E'S' ɂďt@C̑lȗĂꍇAȂɂli[܂B
*  ܂Å֐ĂԑOɃftHglĂƂo܂B
*y⑫z
*Es܂͋s̍sɂĂAĂяo܂B
*E̊֐ԂƂAt@C|C^́As̎ɈړĂ܂B
*yz
*Eattr = 1, string, 2  Ƃl͂ꍇA
*  scanf ƓlɁAȉ̂悤ɋLq܂B
*   IniFile_Read_getVar( file, "attr", "isi", &i1, s, &i2 );
************************************************************************/
long  IniFile_Read_getVar( IniFile_Read* m, const char* attr_name,
  const char* types, ... )
{
  long   pos;
  char*  buf;
  va_list  va;

  pos = ftell( m->file );

  /* `FbN */
  buf = IniFile_Read_readAttrName( m, attr_name );

  /* lǂݍ */
  va_start( va, types );
  IniFile_Read_readVar( m, buf, types, va );
  va_end( va );

  return  pos;
}


 
/***********************************************************************
*  <<< [IniFile_Read_getNextCount] S̐Ԃ >>> 
*y⑫z
*Ẽ݂t@C|C^̈ʒu玟̃ZNV܂ŁA܂̓t@C̏I
*  ܂ł̑̐Ԃ܂B
************************************************************************/
int  IniFile_Read_getNextCount( IniFile_Read* m )
{
  int  count = 0;
  long  pos;
  char*  buf = m->lineBuf;

  pos = ftell( m->file );

  for (;;) {
    fgets( buf, m->lineBuf_sizeof, m->file );
    if ( feof( m->file ) )  break;

    if ( buf[strlen(buf)-1] == '\n' )
      buf[strlen(buf)-1] = '\0';
    StrX_trim( buf );

    if ( ! StrX_isSpaceStr( buf ) ) {
      if ( buf[0] == '[' )  break;
      count ++;
    }
  }

  fseek( m->file, pos, SEEK_SET );
  return  count;
}

 
/***********************************************************************
*  <<< [IniFile_Read_getNextVar] ̑Ƒl͂ >>> 
*yz
*  Echar*  attr_name;  i[AhXiój
*  Echar*  types;      ^Xg
*  E...                ̒li[AhXׂ́iój
*  Elong  Ԃl;      ̑s̐擪̃t@CAhX, -1L=͖
*y⑫z
*Ȇꍇi̍śÃZNV̏ꍇjA-1L Ԃ܂B
************************************************************************/
long  IniFile_Read_getNextVar( IniFile_Read* m, char* attr_name,
  const char* types, ... )
{
  long   pos;
  char*  buf = m->lineBuf;
  char*  p;
  va_list  va;

  pos = ftell( m->file );

  /* s΂āAsǂݍ */
  do {
    fgets( buf, m->lineBuf_sizeof, m->file );
    if ( feof( m->file ) )
      return  -1L;

    if ( buf[strlen(buf)-1] == '\n' )
      buf[strlen(buf)-1] = '\0';
    StrX_trim( buf );
  } while ( StrX_isSpaceStr( buf ) );

  /* ZNV̋؂ɗANULL Ԃ */
  if ( buf[0] == '[' ) {
    fseek( m->file, pos, SEEK_SET );
    return  -1L;
  }

  /* 擾 */
  p = strchr( buf, '=' );
  if ( p != NULL )  *p = '\0';
  StrX_trim( buf );
  strcpy( attr_name, buf );

  /* lǂݍ */
  if ( p == NULL )  p = strchr( buf, '\0' );
  else  p = p + 1;
  va_start( va, types );
  IniFile_Read_readVar( m, p, types, va );
  va_end( va );

  return  pos;
}

 
/***********************************************************************
*  <<< [IniFile_Read_getVarByPos] t@CAhX瑮l͂ >>> 
*yz
*  Elong   pos;        t@CAhX
*  Echar*  types;      ^XgiIniFile_Read_getVar ֐QƁj
*  E...                ̒li[AhXׂ
************************************************************************/
void  IniFile_Read_getVarByPos( IniFile_Read* m, long pos,
  const char* types, ... )
{
  va_list  va;
  char*  buf = m->lineBuf;
  char*  p;

  fseek( m->file, pos, SEEK_SET );

  /* CR[܂ŃXLbv */
  for(;;) {
    fgets( buf, m->lineBuf_sizeof, m->file );
    p = buf;
    while ( *p != '\0' ) {
      if ( *p == '=' )
        goto exit_for;
      p++;
    }
  }
exit_for:

  /* l̐擪܂ŃXLbv */
  p++;
  while ( *p == ' ' )  p++;
  StrX_trim( p );

  /* lǂݍ */
  va_start( va, types );
  IniFile_Read_readVar( m, p, types, va );
  va_end( va );
}


 
/***********************************************************************
*  <<< [IniFile_Read_getPlusVar] l͂iǉpj>>> 
*y⑫z
*Eo[WAbvɂ葮ǉꍇɗeՂɑΉ邽߂
*  IniFile_Read_getVar ֐łB
*Ei[ϐ̌ɁAftHglȉ̂悤Ɏw肵܂B
*  IniFile_Read_getVar( file, "attr", "isi", &i1, s, &i2, 10, "abc", 5 );
*EȂׂÅ֐g킸ɁAo[Wԍɂēǂݍރ[`
*  ς悤ɂĂB
************************************************************************/
void  IniFile_Read_getPlusVar( IniFile_Read* m, const char* attr_name,
  const char* types, ... )
{
  char*  buf;
  va_list  va;
  int*   i;
  char*  s;
  bool*  b;

 // ASSERT( strlen(types) <= 1 );  /*Ή*/

  /* l͂ */
  if ( IniFile_Read_getCount( m, attr_name ) > 0 ) {

    /* `FbN */
    buf = IniFile_Read_readAttrName( m, attr_name );

    /* lǂݍ */
    va_start( va, types );
    IniFile_Read_readVar( m, buf, types, va );
    va_end( va );
  }

  /* ftHgli[ */
  else {
    va_start( va, types );
    switch ( *types ) {
      case 'i':
        i = va_arg( va, int* );
        *i = va_arg( va, int );
        break;
      case 'b':
        b = va_arg( va, bool* );
        *b = va_arg( va, bool );
        break;
      case 's':
        s = va_arg( va, char* );
        strcpy( s, va_arg( va, char* ) );
        break;
    }
    va_end( va );
  }
}
 
/**************************************************************************
*  <<< [IniFile_Read_checkTypeInfo] t@C̃o[Wǂ݂Ń`FbN >>> 
*yz
*Eint  verNum_start;  AvΉĂo[W̍ŏlij
*Eint  verNum_end;    AvΉĂo[W̍őlij
*y⑫z
*EIniFile_Write_putTypeInfo ŏo͂f[^`FbN܂B
*EG[ŁAerror2_2 ĂяoĂ܂B
*  G[R[h́AIniFile_Err_OtherApp  IniFile_Err_OtherVer łB
***************************************************************************/
void  IniFile_Read_checkTypeInfo( IniFile_Read* m, const char* appName,
  int verNum_start, int verNum_end )
{
  int  n;
  char  s[256];

  IniFile_Read_getVar( m, "Application", "s", s );
  if ( strcmp( s, appName ) != 0 ) {
    error2_2( IniFile_Err_OtherApp, "AvP[VقȂ܂ ifile:%s, app:%sj",
      s, appName );
  }
  IniFile_Read_getVar( m, "Version", "i", &n );
  if ( n < verNum_start || n > verNum_end ) {
    error2_3( IniFile_Err_OtherVer, "AvΉĂȂAVo[W̃t@Cł"
      " ifile:%d, app:%d`%dj", n, verNum_start, verNum_end );
  }
}
 
/***********************************************************************
*  <<< [IniFile_Read_getVar2] CӐ̑l͂ >>> 
*yz
*  EStrX_Mem*  mem;    i[̈ ⑫
*  Echar*  attr_name;  
*  Echar*  types;      ^Xg
*  E...                ̒li[AhXׂ
*  Elong  Ԃl;      ̑s̐擪̃t@CAhX
*y⑫z
*Etypes ɕ^w肵Ȃ΁Amem ɂ NULL wł܂B
*Etypes ɂ́Aȉ̌^w蕶ׂw肵܂B
*    E's'  ^ichar* ^Ǎ^ char**j
*    E'i'  ^iint^Ǎ^ int*j
*    E'b'  _^ibool^Ǎ^ bool*j
*    E'*s' z^ǐ^ ArrX_Buf*  ArrX*ji[*1]j
*    E'*i' z^ǐ^ ArrX_Buf*  ArrX*j
*    E'-'  l𖳎ii[ϐw肵Ȃj
*E[*1] types=="*s" ̏ꍇAIniFile_Read_getVar2s ֐֗łB
*EĂƁAO𓊂܂B
*Ezɂ́AArrX_Buf pӂACӂ̗vf̗vfi[邱Ƃ
*  ł܂B
*ElȗꂽꍇA^ł NULL i[A
*  ^ł͉li[܂Bl^ł́Å֐ĂԑO
*  ftHglĂƂo܂B
*y⑫z
*Es܂͋s̍sɂĂAĂяo܂B
*E̊֐ԂƂAt@C|C^́As̎ɈړĂ܂B
*yz
*Eattr = 1, string, 2  Ƃl͂ꍇA
*  scanf ƓlɁAȉ̂悤ɋLq܂B
*  ÁAchar** ^w肷邱ƂɒӂĂ
*   IniFile_Read_getVar2( file, mem, "attr", "isi", &i1, &s, &i2 );
*Eattr = 1, 2, 4, 6 Ƃlzɓ͂ꍇA
*  ȉ̂悤ɋLq܂B
*   IniFile_Read_getVar2( file, mem, "attr", "*i", buf, arr );
*   Aarr ̃̈ buf mۂ܂B
*    EArrX_Buf* buf;  z̗̈iς݂wj
*    EArrX* arr;      ziԂ̂wj
*Eattr = 1, abc, def, ghi Ƃl̂A2(abc)ȍ~
+  zɓ͂ꍇAȉ̂悤ɋLq܂B
*   IniFile_Read_getVar2( file, mem, "attr", "i*s", &i, buf, arr );
************************************************************************/
#ifdef  USES_STRX
long  IniFile_Read_getVar2( IniFile_Read* m, StrX_Mem* mem,
  const char* attr_name, const char* types, ... )
{
  long   pos;
  char*  buf;
  va_list  va;

  pos = ftell( m->file );

  /* `FbN */
  buf = IniFile_Read_readAttrName( m, attr_name );

  /* lǂݍ */
  va_start( va, types );
  IniFile_Read_readVar2( m, buf, mem, types, va );
  va_end( va );

  return  pos;
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Read_getVar2s] CӐ̕^l͂(StrX_Mem) >>> 
*yz
*  EStrX_Mem*  mem;    i[̈ ⑫
*  Echar*  attr_name;  
*  EStrX_Set*  set;    ͂iji[Wiój
*  Elong  Ԃl;      ̑s̐擪̃t@CAhX
************************************************************************/
#ifdef  USES_STRX
long  IniFile_Read_getVar2s( IniFile_Read* m, StrX_Mem* mem,
  const char* attr_name, StrX_Set* set )
{
  long  ret;

  StrX_Set_init1( set, mem );
  ret = IniFile_Read_getVar2( m, mem, attr_name, "*s", NULL, NULL );
  StrX_Set_init2( set, mem );

  return  ret;
}
#endif


 
/***********************************************************************
*  <<< [IniFile_Read_getVar2sv] CӐ̕^l͂(StrV_Mem) >>> 
*yz
*  EStrV_Mem*  mem;    i[̈ ⑫
*  Echar*  attr_name;  
*  EStrV_Set*  set;    ͂iji[Wiój
*  Elong  Ԃl;      ̑s̐擪̃t@CAhX
************************************************************************/
#ifdef USES_ARRX
#ifdef USES_STRV
void  IniFile_Read_getVar2sv( IniFile_Read* m, StrV_Mem* mem,
  const char* attr_name, StrV_Set* set )
{
  char*  vars;
  char*  nextVar;

  StrV_Set_init1( set, mem );
  vars = IniFile_Read_readAttrName( m, attr_name );
  StrV_Mem_setMax( mem, m->string_sizeof );

  for (;;) {

    nextVar = StrX_meltCSV( vars, vars );
    strcpy( StrV_Mem_alloc( mem ), vars );

    if ( nextVar == NULL )  break;

    /* ̒li[鏀 */
    vars = nextVar;
    while ( *vars == ' ' )  vars ++;
  }
  StrV_Set_init2( set, mem );
}
#endif
#endif


 
/***********************************************************************
*  <<< [IniFile_Read_getVar2av] StrV_AbleElem ^͂̕ >>> 
*yz
*  Echar*  attr_name;   
*  EArrX_Able*  set;    ͂i[ StrV_AbleElem ^\̂̏W
*y⑫z
*Eset ̖ɂȂĂvfɒǉ܂B
************************************************************************/
#ifdef USES_ARRX
#ifdef USES_STRV
void  IniFile_Read_getVar2av( IniFile_Read* m, const char* attr_name,
  ArrX_Able* set )
{
  char*  vars;
  char*  nextVar;
  StrV_AbleElem*  s;

  vars = IniFile_Read_readAttrName( m, attr_name );

  for (;;) {

    nextVar = StrX_meltCSV( vars, vars );
    s = ArrX_Able_getFirstDisabled( set, StrV_AbleElem );
    StrV_cpy( &s->s, vars );

    if ( nextVar == NULL )  break;

    /* ̒li[鏀 */
    vars = nextVar;
    while ( *vars == ' ' )  vars ++;
  }
}
#endif
#endif
 
/***********************************************************************
*  <<< [IniFile_Read_getPlusVar2] CӐ̑l͂iǉpj>>> 
*y@\z
*EStrX_Mem w肷 IniFile_Read_getPlusVar ֐łB
*y⑫z
*EÃftHgl͂ꍇAStrX_Mem gpȂŁA
*  w肵ftHgQƂ悤ɂ܂BAftHg
*  ei萔jłȂꍇAӂĂB
************************************************************************/
#ifdef  USES_STRX
void  IniFile_Read_getPlusVar2( IniFile_Read* m, StrX_Mem* mem,
  const char* attr_name, const char* types, ... )
{
  char*   buf;
  va_list va;
  int*    i;
  char**  s;
  bool*   b;

  ASSERT( strlen(types) == 1 );  /*Ή*/

  /* l͂ */
  if ( IniFile_Read_getCount( m, attr_name ) > 0 ) {

    /* `FbN */
    buf = IniFile_Read_readAttrName( m, attr_name );

    /* lǂݍ */
    va_start( va, types );
    IniFile_Read_readVar2( m, buf, mem, types, va );
    va_end( va );
  }

  /* ftHgli[ */
  else {
    va_start( va, types );
    switch ( *types ) {
      case 'i':
        i = va_arg( va, int* );
        *i = va_arg( va, int );
        break;
      case 'b':
        b = va_arg( va, bool* );
        *b = va_arg( va, bool );
        break;
      case 's':
        s = va_arg( va, char** );
        *s = va_arg( va, char* );  /* QƂ */
        break;
    }
    va_end( va );
  }
}
#endif


 
/***********************************************************************
*  <<< [IniFile_Read_getVars] ̍\̂A͂ >>> 
*yz
*  EStrX_Mem*  mem;     i[̈
*  EArrX_Buf*  pmem;    \̂i[̈
*  Echar*      attr_name;  
*  Echar*      types;   ^Xg
*  EArrX*      arr;     \̔ziój
*y⑫z
*E^XgɊւẮAIniFile_Read_getVar2 ֐QƁB
*EƂ΁Atypes="isi" ȂAȉ̍\̂̔z arr Ɋi[܂B
*  struct { int p1; char* p2; int p3; };
*  t@Cł͎̂悤Ȍ`ɂȂ܂B
*    Struct = 1, abc, 11
*    Struct = 2, efg, 22
*       :         :
*  A\̗̂̈ pmemÄ̗ mem gp܂B
*EszAzvfƂ݂ȂꍇAIniFile_Read_getVar2 g܂B
*E^XgɎw肷vfP̏ꍇA\̂łȂ{^ō\܂B
*  Ƃ΁Atypes="i" ȂAArrX ́Aint ^̔zɂȂ܂B
*Earr == NULL ̏ꍇApmem Ɋi[邾łB
************************************************************************/
#ifdef USES_ARRX
#ifdef  USES_STRX
void  IniFile_Read_getVars( IniFile_Read* m, StrX_Mem* mem, ArrX_Buf* pmem,
  const char* attr_name, const char* types, ArrX* arr )
{
  int   i,n;
  int*  pp_first;  /* ŏ̍\̂ւ̃|C^ */
  int*  pp;        /* ݂̍\̂ւ̃|C^ */
  char* buf;       /* sobt@݂̌̒l̈ʒu */
  char* nextBuf;   /*  buf */
  const char* t;   /* types ̃|C^ */

  ASSERT( sizeof(int) == sizeof(char*) );

  n = IniFile_Read_getCount( m, attr_name );
  pp_first = ArrX_Buf_allocs( pmem, int, n * strlen( types ) );
  pp = pp_first;
  for ( i = 0; i < n; i++ ) {
    t = types;
    buf = IniFile_Read_readAttrName( m, attr_name );
    if ( *t != '\0' ) {
      for (;;) {

        /* l̕ */
        nextBuf = StrX_meltCSV( buf, buf );

        /* ꂼ̌^̒lǂݍ */
        switch ( *t ) {
          case  's':
            if ( (int)strlen( buf ) > m->string_sizeof - 1 )
              buf[m->string_sizeof - 1] = '\0';
            *pp = (int)StrX_Mem_alloc( mem );
            strcpy( (char*)*pp, buf );
            break;
          case  'i':
            *pp = atoi( buf );
            break;
          #ifdef USES_TIMEDATE
            case 't':
              TimeDate_loadStr( pp, buf );
              break;
          #endif
          default:
            Errors_notSupport();
        }
        pp ++;
        t ++;
        if ( *t == '\0' )
          break;

        if ( nextBuf == NULL ) {
          error2_1( IniFile_Err_FewData,
            "%s ̃f[^̂Ȃ", attr_name );
        }
        buf = nextBuf + 1;
        while ( *buf == ' ' )  buf ++;
      }
    }
  }
  if ( arr != NULL )
    ArrX_init2( arr, pp_first, pp );
}
#endif
#endif /* USES_ARRX */


 
/***********************************************************************
*  <<< [IniFile_Read_getVars2] ̍\̂A͂Q >>> 
*yz
*  EStrX_Mem*  mem;     i[̈
*  EArrX_Buf*  pmem;    \̂i[̈
*  Echar*      attr_name;  
*  Echar*      types;   ^Xg
*  EArrX*      arr;     \̔ziój,܂ NULL
*  Eint        size;    P̍\̂̃TCY
*  E...                 ItZbgliOffset^j̗
*y⑫z
*EIniFile_Read_getVars Ƃ̈Ⴂ́A\̃oւ̊i[Cӂ
*  wł邱ƂłB
*EƂ΁Atypes="si" ŁAȉ̍\́i̔zjɊi[ꍇA
*  ... ͎̈̂悤Ɏw肵܂B
*  struct { int p1; char* p2; int p3; };
*   Offset_init2(s,p2), Offset_init2(s,p3)
*   s ́A\̂ւ̔Cӂ̃|C^ƂB
*Earr == NULL ̏ꍇApmem Ɋi[邾łB
************************************************************************/
#ifdef USES_ARRX
#ifdef USES_STRX
#ifdef USES_OFFSET
void  IniFile_Read_getVars2( IniFile_Read* m, StrX_Mem* mem, ArrX_Buf* pmem,
  const char* attr_name, const char* types, ArrX* arr, int size, ... )
{
  va_list  va;
  int   i,n;
  char*  pp_first;  /* ŏ̍\̂ւ̃|C^ */
  char*  pp;        /* ݂̍\̂ւ̃|C^ */
  char*  pp2;       /* \̂̃oϐւ̃|C^ */
  char*  buf;       /* sobt@݂̌̒l̈ʒu */
  char*  nextBuf;   /*  buf */
  const char* t;   /* types ̃|C^ */

  ASSERT( sizeof(int) == sizeof(char*) );

  n = IniFile_Read_getCount( m, attr_name );
  pp_first = ArrX_Buf_allocs( pmem, char, n * size );
  pp = pp_first;
  for ( i = 0; i < n; i++ ) {
    t = types;
    buf = IniFile_Read_readAttrName( m, attr_name );
    va_start( va, size );
    if ( *t != '\0' ) {
      for (;;) {

        /* l̕ */
        nextBuf = StrX_meltCSV( buf, buf );

        /* ItZbg */
        pp2 = &Offset_ref( va_arg(va,int), pp, char );

        /* ꂼ̌^̒lǂݍ */
        switch ( *t ) {
          case  's':
            if ( (int)strlen( buf ) > m->string_sizeof - 1 )
              buf[m->string_sizeof - 1] = '\0';
            *(char**)pp2 = StrX_Mem_alloc( mem );
            strcpy( *(char**)pp2, buf );
            break;
          case  'i':
            *(int*)pp2 = atoi( buf );
            break;
          #ifdef USES_TIMEDATE
            case 't':
              TimeDate_loadStr( (time_t*)pp2, buf );
              break;
          #endif
        }
        t ++;
        if ( *t == '\0' )
          break;

        if ( nextBuf == NULL ) {
          error2_1( IniFile_Err_FewData,
            "%s ̃f[^̂Ȃ", attr_name );
        }
        buf = nextBuf + 1;
        while ( *buf == ' ' )  buf ++;
      }
    }
    pp += size;
    va_end( va );
  }
  if ( arr != NULL )
    ArrX_init2( arr, pp_first, pp );
}
#endif /* USES_OFFSET */
#endif
#endif /* USES_ARRX */


 
/***********************************************************************
*  <<< [IniFile_Read_getMultiLine] s͂ >>> 
*yz
*  Echar* attr_name;  
*  Echar* buf;        sobt@
*  Eint   buf_sizeof; buf ̗̈̃TCY
*  Echar* retStr;     si"\r\n""\n"j
*  Echar* Ԃl;     buf
*y⑫z
*EĂƁAO𓊂܂B
*EśAt@Cł́Â悤ɓ܂B
*  attr = text of line 1
*  attr = text of line 2
*  attr = text of line 3
*EPs IniFile_Read_setStringSize Őݒ肵l̃oCg
*  ǂݍނƂł܂BtɁAݒ肵l傫ƁA̍s
*  ǂݍނ߂ buf ̗]TɖȂ܂B
************************************************************************/
char*  IniFile_Read_getMultiLine( IniFile_Read* m, const char* attr_name,
  char* retStr, char* buf, int buf_sizeof )
{
  int  i,n;
  char*  p;
  char*  p_over;

  p = buf;
  p_over = buf + buf_sizeof;

  n = IniFile_Read_getCount( m, attr_name );
  for ( i = 0; i < n; i++ ) {
    if ( p_over - p < m->string_sizeof ) {
      error2_1( IniFile_Err_FewBuf,
        "obt@̈悪Ȃi%sj", attr_name );
    }
    IniFile_Read_getVar( m, attr_name, "s", p );
    p = strchr( p, '\0' );
    strcat( p, retStr );
    p = strchr( p, '\0' );
  }
  *p = '\0';

  return  buf;
}


 
/***********************************************************************
*  <<< [IniFile_Read_getMultiLineM] s͂ >>> 
*yz
*  Echar*   attr_name;  
*  Echar*   mem;        i[̈
*  Echar**  var;        ichar*j̃AhX
*  Echar*   retStr;     si"\r\n""\n"j
*y⑫z
*EIniFile_Read_getMultiLine ֐ StrX_Mem gp^CvłB
************************************************************************/
#ifdef  USES_STRX
void  IniFile_Read_getMultiLineM( IniFile_Read* m, StrX_Mem* mem,
  const char* attr_name, char* retStr, char** var )
{
  *var = StrX_Mem_alloc( mem );
  IniFile_Read_getMultiLine( m, attr_name, retStr,
    *var, StrX_Mem_getLeftSize( mem ) );
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Read_getMultiStr] s𕡐̕Ƃē͂(StrX_Set) >>> 
*yz
*  Echar*  attr_name;  
*  EStrX_Mem*  buf;    i[̈
*  EStrX_Set*  set;    ̕W
*y⑫z
*Eset ͏܂B
*EŁAStrX_Mem_alloc ĂяoĂ܂B
*EśAt@Cł́Â悤ɓ܂B
*  attr = text of line 1
*  attr = text of line 2
*  attr = text of line 3
************************************************************************/
#ifdef  USES_STRX
#ifdef  USES_ARRX
void  IniFile_Read_getMultiStr( IniFile_Read* m, StrX_Mem* buf,
  const char* attr_name, StrX_Set* set )
{
  StrX_Set_init1( set, buf );
  IniFile_Read_getMultiStrM( m, attr_name, buf );
  StrX_Set_init2( set, buf );
}
#endif
#endif


 
/***********************************************************************
*  <<< [IniFile_Read_getMultiStrM] s𕡐̕Ƃē͂(StrX_Mem) >>> 
*yz
*  Echar*  attr_name;  
*  EStrX_Mem*  buf;    i[̈
*y⑫z
*EIniFile_Read_getMultiStr Ƃ̈Ⴂ́AStrX_Set Ɋi[Ȃ
*  łB
************************************************************************/
#ifdef  USES_STRX
#ifdef  USES_ARRX
void  IniFile_Read_getMultiStrM( IniFile_Read* m, const char* attr_name,
  StrX_Mem* buf )
{
  int  i,n;
  char*  s;

  n = IniFile_Read_getCount( m, attr_name );
  for ( i = 0; i < n; i++ ) {
    s = StrX_Mem_alloc( buf );
    if ( (int)StrX_Mem_getLeftSize( buf ) < m->string_sizeof ) {
      error2_0( IniFile_Err_FewBuf, "̊i[̈悪܂" );
    }
    IniFile_Read_getVar( m, attr_name, "s", s );
  }
}
#endif
#endif


 
/***********************************************************************
*  <<< [IniFile_Read_getMultiStrV] s𕡐̕Ƃē͂(StrV_Set) >>> 
*yz
*  Echar*  attr_name;  
*  EStrV_Mem*  buf;    i[̈
*  EStrV_Set*  set;    ̕W
*y⑫z
*Eset ͏܂B
*EŁAStrV_Mem_alloc ĂяoĂ܂B
*EśAt@Cł́Â悤ɓ܂B
*  attr = text of line 1
*  attr = text of line 2
*  attr = text of line 3
************************************************************************/
#ifdef  USES_STRV
void  IniFile_Read_getMultiStrV( IniFile_Read* m, StrV_Mem* buf,
  const char* attr_name, StrV_Set* set )
{
  int  i,n;
  char*  s;

  StrV_Set_init1( set, buf );
  StrV_Mem_setMax( buf, m->string_sizeof );
  n = IniFile_Read_getCount( m, attr_name );
  for ( i = 0; i < n; i++ ) {
    s = StrV_Mem_alloc( buf );
    IniFile_Read_getVar( m, attr_name, "s", s );
  }
  StrV_Set_init2( set, buf );
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Read_getMultiStrAV] s𕡐̕Ƃē͂(ArrX_Able) >>> 
*yz
*  Echar*  attr_name;  
*  EArrX_Able*  set;   StrV_AbleElem ^̏̕W
*y⑫z
*Eset ͏܂B
*EŁAStrV_Mem_alloc ĂяoĂ܂B
*EśAt@Cł́Â悤ɓ܂B
*  attr = text of line 1
*  attr = text of line 2
*  attr = text of line 3
************************************************************************/
#ifdef  USES_BIGSTACK
#ifdef  USES_STRV
void  IniFile_Read_getMultiStrAV( IniFile_Read* m,
  const char* attr_name, ArrX_Able* set )
{
  int  i,n;
  char*  s;
  StrV_AbleElem*  sv;
  bool  bStack = false;

  c_try {
    BigStack_start();  bStack = true;
    s = BigStack_alloc( m->string_sizeof );
    n = IniFile_Read_getCount( m, attr_name );
    for ( i = 0; i < n; i++ ) {
      sv = ArrX_Able_getFirstDisabled( set, StrV_AbleElem );
      if ( sv == NULL )  error();
      IniFile_Read_getVar( m, attr_name, "s", s );
      StrV_cpy( &sv->s, s );
      ArrX_AbleElem_setAble( sv, true );
    }
  }
  c_finally {
    if ( bStack )  BigStack_end();
  } c_end_finally;
}
#endif
#endif

 
/***********************************************************************
*  <<< [IniFile_Read_getPathes] t@CpX̏W͂ >>> 
*yz
*  EStrX_Mem*  mem;     i[̈
*  EArrX_Buf*  pmem;    char* ^̔zi[̈
*  Echar*      section_name;  ZNV
*  EArrX*      arr;     t@CEpX̔ziój
*y⑫z
*EłȂAZNVw肷邱ƂɒӂĂB
*  ܂AZNVŜAt@CpX̐p̈ɂȂ܂B
*E^XgɊւẮAIniFile_Read_getVar2 ֐QƂĂB
*EIniFile_Write_putPathes ֐ɂďo͂ꂽf[^͂ł܂B
*E擾pX́Aini t@C̓eɂđ΃pX΃pXقȂ܂B
*Eini t@ĆAҏW₷悤ɁÂ悤ȍ\ɂȂĂƂ܂B
*  [uses]
*  Folder = .           ... tH_pX
*  File = main.c        ... t@C
*  File = main2.c
*  Folder = ..\inc
*  File = sub1.h
*  File = sub2.h
*  File = sub3.h
*  AFolder ́A΃pXł\܂B
************************************************************************/
#ifdef  USES_ARRX
#ifdef  USES_STRX
void  IniFile_Read_getPathes( IniFile_Read* m, StrX_Mem* mem,
  ArrX_Buf* pmem, const char* section_name, ArrX* arr )
{
  int    i;
  int    nFolder;   /* Folder ̐ */
  long   sect_top;  /* ZNV̐擪̃t@CAhX */
  char** pp = NULL;        /* t@C(char*^)ւ̃|C^ */
  char** pp_first = NULL;  /* pp ̐擪 */
  char*  buf = m->lineBuf;

  /* ZNV */
  sect_top = IniFile_Read_searchSection( m, section_name, true );

  /* Folder 邩 */
  nFolder = 0;
  for(;;) {
    fgets( buf, m->lineBuf_sizeof, m->file );
    if ( feof( m->file ) )
      break;
    if ( buf[0] == '[' )
      break;
    if ( strncmp( buf, "Folder", 6 ) == 0 &&
         ( *(buf + 6) == ' ' || *(buf + 6) == '=' ) )
      nFolder ++;
  }

  /* t@CpX͂ */
  fseek( m->file, sect_top, SEEK_SET );
  for ( i = 0; i < nFolder; i++ ) {
    static char  folder[_MAX_PATH];
    int  ii, nFile;

    IniFile_Read_getVar( m, "Folder", "s", folder );
    nFile = IniFile_Read_getCount( m, "File" );
    pp = ArrX_Buf_allocs( pmem, char*, nFile );
    if ( i == 0 )  pp_first = pp;

    for ( ii = 0; ii < nFile; ii++ ) {
      IniFile_Read_getVar2( m, mem, "File", "s", pp );
      StrX_toAbsPath( *pp, StrX_Mem_getLeftSize(mem), folder );
      pp++;
    }
  }
  ArrX_init2( arr, pp_first, pp );
}
#endif
#endif /* USES_ARRX */


 
/***********************************************************************
*  <<< [IniFile_Read_getPathesS] t@CpX̏W͂ >>> 
*y⑫z
*EIniFile_Read_getPathes Ƃ̈Ⴂ́AArrX_Buf gpȂŁA
*  StrX_Set 邱ƂłB
************************************************************************/
#ifdef  USES_ARRX
#ifdef  USES_STRX
void  IniFile_Read_getPathesS( IniFile_Read* m, StrX_Mem* mem,
  const char* section_name, StrX_Set* set )
{
  static char*  bufX[1024];
  ArrX_Buf  buf;
  ArrX      dummy;

  ArrX_Buf_init( &buf, bufX, sizeof(bufX) );

  StrX_Set_init1( set, mem );
  IniFile_Read_getPathes( m, mem, &buf, section_name, &dummy );
  StrX_Set_init2( set, mem );
}
#endif
#endif

 
/* <<< ------- p ------- >>> */ 


 
/***********************************************************************
*  <<< [IniFile_Read_readAttrName] `FbN >>> 
*yz
*  Echar* attr_name;  
*  Echar* Ԃl;     sobt@̒l̈ʒu
*y⑫z
*EpłB
*y⑫z
*EĂƁAO𓊂܂B
*Es܂͋s̍sɂĂAĂяo܂B
*E̊֐ԂƂAt@C|C^́As̎ɈړĂ܂B
************************************************************************/
char*  IniFile_Read_readAttrName( IniFile_Read* m, const char* attr_name )
{
  char*  buf = m->lineBuf;
  char*  p;
  int  c;

  /* s΂āAsǂݍ */
  do {
    fgets( buf, m->lineBuf_sizeof, m->file );
    if ( buf[strlen(buf)-1] == '\n' )
      buf[strlen(buf)-1] = '\0';

    if ( feof( m->file ) ) {
      error2_1( IniFile_Err_FewAttr, "Ȃ", attr_name );
    }
  } while ( buf[0] == '\0' );

  /* `FbN */
  while ( *buf == ' ' || *buf == '\t' ) {
    if ( *buf == '\0' )  break;
    buf++;
  }
  p = &buf[strlen(attr_name)];
  c = *p;
  *p = '\0';
  if ( c != ' ' && c != '=' && c != ':' ) {
    error2_3( IniFile_Err_BadAttr,
      "قȂiAv=%s, t@C=%s in %sj",
      attr_name, buf, m->path );
  }
  if ( stricmp( buf, attr_name ) != 0 ) {
    error2_3( IniFile_Err_BadAttr,
      "قȂiAv=%s, t@C=%s in %sj",
      attr_name, buf, m->path );
  }

  /* 󔒂ƃCR[iRjXLbv */
  p++;
  while ( *p == ' ' )  p++;
  if ( *p == '=' || *p == ':' )  p++;
  while ( *p == ' ' )  p++;

  return  p;
}


 
/***********************************************************************
*  <<< [IniFile_Read_readVar] lǂݍ >>> 
*yz
*  Echar* vars;   t@Csobt@̒l̈ʒu
*  Echar* types;  ^Xg
*y⑫z
*EpłB
*y⑫z
*Eڍׂ́AIniFile_Read_getVar ֐̉QƂĂB
************************************************************************/
#ifdef  USES_STRX
void  IniFile_Read_readVar( IniFile_Read* m, char* vars,
  const char* types, va_list va )
{
  char*  nextVar;

  if ( *types != '\0' ) {
    for (;;) {

      /* l̕ */
      nextVar = StrX_meltCSV( vars, vars );

      /* ꂼ̌^̃ftHglݒ肷irj */
      if ( *vars == '\0' ) {
        switch( *types ) {
          case 's':  strcpy( va_arg( va, char* ), "" );  break;
          case 'i':  *va_arg( va, int* ) = 0;  break;
          case 'b':  *va_arg( va, bool* ) = false;  break;
        }
      }
      /* ꂼ̌^̒lǂݍ */
      else {
char* aa;
        switch ( *types ) {
          case  's':
          case  'S':
            if ( (int)strlen( vars ) > m->string_sizeof - 1 )
              vars[m->string_sizeof - 1] = '\0';
            aa = va_arg( va, char* );
            strcpy( aa, vars );
            break;
          case  'i':
          case  'I':
            *va_arg( va, int* ) = atoi( vars );
            break;
          case  'b':
            *va_arg( va, bool* ) = ( *vars != '0' );
            break;
          #ifdef USES_TIMEDATE
            case 't':
              TimeDate_loadStr( va_arg( va, time_t* ), vars );
              break;
          #endif
          default:
            ASSERT( *types == '-' );
            break;
        }
      }

      /* ̍ڂւ̏ */
      types ++;  if ( *types == '\0' )  break;

      if ( nextVar == NULL )  break;
      vars = nextVar;
    }

    /* ꂼ̌^̃ftHglݒ肷ij */
    while ( *types != '\0' ) {
char*  aa;
      switch ( *types ) {
        case 's':  aa = va_arg( va, char* );  aa[0] = '\0';  break;
        case 'i':  *va_arg( va, int* ) = 0;  break;
        case 'b':  *va_arg( va, bool* ) = false;  break;
      }
      types ++;
    }
  }
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Read_readVar2] lǂݍ(StrX_Memgp) >>> 
*yz
*  Echar* vars;     t@Csobt@̒l̈ʒu
*  EStrX_Mem* mem;  i[̈
*  Echar* types;    ^Xg
*y⑫z
*EpłB
*y⑫z
*Eڍׂ́AIniFile_Read_getVar2 ֐̉QƂĂB
************************************************************************/
#ifdef  USES_STRX
void  IniFile_Read_readVar2( IniFile_Read* m, char* vars,
  StrX_Mem* mem, const char* types, va_list va )
{
  char*  nextVar;
  char** pp;

  if ( *types != '\0' ) {
    for (;;) {

      /* zɍs܂ł̗vfǂݍ */
      #ifdef USES_ARRX
        if ( *types == '*' ) {
          types++;
          IniFile_Read_readVar2_subA( m, vars, mem, types, va );
          return;
        }
      #endif

      /* l̕ */
      nextVar = StrX_meltCSV( vars, vars );

      /* ꂼ̌^̒lǂݍ */
      switch ( *types ) {
        case  's':
        case  'S':
          pp = va_arg(va, char**);
          if ( *vars == '\0' ) {
            if ( *types == 'S' )  *pp = StrX_Mem_alloc(mem);
            else   *pp = NULL;
          }
          else
            IniFile_Read_readVar2_subS( m, vars, pp, mem );
          break;

        case  'i':
          if ( *vars != '\0' ) {
            *va_arg( va, int* ) = atoi( vars );
          }
          break;
        case  'b':
          if ( *vars != '\0' ) {
            *va_arg( va, bool* ) = ( *vars != '0' );
          }
          break;
        #ifdef USES_TIMEDATE
          case 't':
            if ( *vars != '\0' ) {
              TimeDate_loadStr( va_arg( va, time_t* ), vars );
            }
            break;
        #endif
        default:
          ASSERT( *types == '-' );
          break;
      }

      /* ̍ڂւ̏ */
      types ++;  if ( *types == '\0' )  break;

      if ( nextVar == NULL )  break;
      vars = nextVar;
    }
  }
}
#endif

 
/***********************************************************************
*  <<< [IniFile_Read_readVar2_subA] lzɓǂݍ(StrX_Memgp) >>> 
*y⑫z
*EpłB
*y⑫z
*E*types ́A's'  'i' ̃AhXɂĂB
*Eڍׂ́AIniFile_Read_readVar2 ֐QƂĂB
************************************************************************/
#ifdef  USES_ARRX
#ifdef  USES_STRX
void  IniFile_Read_readVar2_subA( IniFile_Read* m, char* vars,
  StrX_Mem* mem, const char* types, va_list va )
{
  ArrX_Buf*  pmem = va_arg( va, ArrX_Buf* );
  ArrX*      arr = va_arg( va, ArrX* );
  void**  pp;        /* pmem mۂ̈̃AhX */
  char*   ppX;       /* pmem == NULL ̂Ƃ pp ̎QƐi_~[j*/
  void**  pp_first;  /* ŏ pp */
  char*   nextVar;   /* ̒l */


  /* Pvfꍇ */
  if ( StrX_isSpaceStr( vars ) ) {
    if ( arr != NULL )  ArrX_init2( arr, NULL, NULL );
    return;
  }

  /* vfꍇ */
  if ( pmem != NULL )  pp_first = pp = ArrX_Buf_alloc( pmem, void* );
  else  pp = (void**)&ppX;
  for (;;) {

    /* l̕ */
    nextVar = StrX_meltCSV( vars, vars );

    /* ꂼ̌^̒lǂݍ */
    switch ( *types ) {
      case  's':
        IniFile_Read_readVar2_subS( m, vars, (char**)pp, mem );
        break;
      case  'i':
        *(int*)pp = atoi( vars );
        break;
      case  'b':
        *(bool*)pp = ( *vars != '0' );
        break;
    #ifdef USES_TIMEDATE
      case  't':
        TimeDate_loadStr( (time_t*)pp, vars );
        break;
    #endif
      default:
        ASSERT( *types == '-' );
        break;
    }

    /* [vI */
    if ( nextVar == NULL )
      break;

    /* ̒li[鏀 */
    vars = nextVar;
    while ( *vars == ' ' )  vars ++;
    if ( pmem != NULL )
      pp = ArrX_Buf_alloc( pmem, void* );
  }

  /* z */
  pp++;
  if ( arr != NULL )  ArrX_init2( arr, pp_first, pp );
}
#endif
#endif /* USES_ARRX */
 
