/***********************************************************************
*  <<< t@C (IniFile) >>> 
************************************************************************/

#ifndef __INIFILE_H
#define __INIFILE_H

#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#ifndef  USES_INIFILE
#define  USES_INIFILE

#define  STDLIBS_INCLUDE
#define  STDLIBS_INCLUDE_STDIO_H
#define  STDLIBS_INCLUDE_STDLIB_H
#define  STDLIBS_INCLUDE_STRING_H
#define  STDLIBS_INCLUDE_STDARG_H

#endif

/*[END_OF_PRIORITY_HEADER]*/
#endif /* USES_PRIORITY_HEADER */

typedef struct _IniFile_Read  IniFile_Read;
typedef struct _IniFile_Write IniFile_Write;

#define  IniFile_NotFoundSection (591)  /* [Compone_GID:Errors_Code] */
#define  IniFile_Err_FewBuf      (592)  /* [Compone_GID:Errors_Code] */
#define  IniFile_Err_BadFormat   (593)  /* [Compone_GID:Errors_Code] */
#define  IniFile_Err_FewData     (594)  /* [Compone_GID:Errors_Code] */
#define  IniFile_Err_FewAttr     (595)  /* [Compone_GID:Errors_Code] */
#define  IniFile_Err_BadAttr     (596)  /* [Compone_GID:Errors_Code] */
#define  IniFile_Err_OtherApp    (597)  /* [Compone_GID:Errors_Code] */
#define  IniFile_Err_OtherVer    (598)  /* [Compone_GID:Errors_Code] */


#ifdef __cplusplus
extern "C" {
#endif


 
/*---------------------------------------------------------------------*/
/* <<< Interface Area --------------------------------------------->>> */ 
/*---------------------------------------------------------------------*/


 
/***********************************************************************
*  <<< [IniFile_Write] t@CE݃c[ >>> 
*y⑫z
*E̕⑫t@ĆAWindows  ini t@CƊS݊łB
*E\GfB^it[\tgjɑΉĂ܂B
************************************************************************/
struct _IniFile_Write {
  FILE*  file;
  bool   firstSection;
};
void  IniFile_Write_init( IniFile_Write*, const char* fname );
void  IniFile_Write_finish( IniFile_Write* );

void  IniFile_Write_putSection( IniFile_Write*, const char* section );
void  IniFile_Write_putVar( IniFile_Write*, const char* attr_name,
  const char* types, ... );
void  IniFile_Write_putLabel( IniFile_Write*, const char* label );
void  IniFile_Write_putMultiLine( IniFile_Write*, const char* attr_name,
  const char* retStr, const char* s );

void  IniFile_Write_putTypeInfo( IniFile_Write*, const char* appName,
  int verNum );

#ifdef  USES_STRV
 void  IniFile_Write_putMultiStrV( IniFile_Write*, const char* attr_name,
   StrV_Set* strs );
 void  IniFile_Write_putMultiStrVM( IniFile_Write*, const char* attr_name,
   StrV_Mem* strs );
 void  IniFile_Write_putMultiStrAV( IniFile_Write*, const char* attr_name,
   ArrX_Able* strs );
#endif

void  IniFile_Write_putPathes( IniFile_Write*, const char* section_name,
  char** pathes, int nPath );


 
/***********************************************************************
*  <<< [IniFile_Read] t@CEǂݍ݃c[ >>> 
************************************************************************/
struct _IniFile_Read {
  FILE*  file;
  char*  lineBuf;
  int    lineBuf_sizeof;
  int    string_sizeof;
  char   path[_MAX_PATH];
};
void  IniFile_Read_init( IniFile_Read*, const char* fname,
  char* lineBuf, int lineBuf_sizeof );
void  IniFile_Read_finish( IniFile_Read* );

void  IniFile_Read_reset( IniFile_Read* );
void  IniFile_Read_setStringSize( IniFile_Read*, int size );
void  IniFile_Read_setSection( IniFile_Read*, const char* section );
long  IniFile_Read_searchSection( IniFile_Read*, const char* section,
  bool upward );
void  IniFile_Read_searchSection2( IniFile_Read*, const char* section,
  const char* attr, const char* type, ... );

int   IniFile_Read_getCount( IniFile_Read*, const char* attr_name );
long  IniFile_Read_getVar( IniFile_Read*, const char* attr_name,
  const char* types, ... );
int  IniFile_Read_getNextCount( IniFile_Read* );
long  IniFile_Read_getNextVar( IniFile_Read*, char* attr_name,
  const char* types, ... );
void  IniFile_Read_getVarByPos( IniFile_Read*, long pos,
  const char* types, ... );
void  IniFile_Read_getPlusVar( IniFile_Read*, const char* attr_name,
  const char* types, ... );

void  IniFile_Read_checkTypeInfo( IniFile_Read*, const char* appName,
  int verNum_start, int verNum_end );

#ifdef  USES_STRX
long  IniFile_Read_getVar2( IniFile_Read*, StrX_Mem* mem,
  const char* attr_name, const char* types, ... );
long  IniFile_Read_getVar2s( IniFile_Read*, StrX_Mem* mem,
  const char* attr_name, StrX_Set* set );
void  IniFile_Read_getPlusVar2( IniFile_Read*, StrX_Mem* mem,
  const char* attr_name, const char* types, ... );
#endif

#ifdef USES_ARRX
  #ifdef  USES_STRV
    void  IniFile_Read_getVar2sv( IniFile_Read*, StrV_Mem* mem,
      const char* attr_name, StrV_Set* set );
    void  IniFile_Read_getVar2av( IniFile_Read*, const char* attr_name,
      ArrX_Able* set );
  #endif
  #ifdef  USES_STRX
    void  IniFile_Read_getVars( IniFile_Read*, StrX_Mem* mem, ArrX_Buf* pmem,
      const char* attr_name, const char* types, ArrX* arr );
    #ifdef USES_OFFSET
      void  IniFile_Read_getVars2( IniFile_Read*, StrX_Mem* mem, ArrX_Buf* pmem,
        const char* attr_name, const char* types, ArrX* arr, int size, ... );
    #endif
  #endif
#endif

#ifdef USES_ARRX
 #ifdef USES_STRX
  void  IniFile_Read_getPathes( IniFile_Read*, StrX_Mem* mem,
    ArrX_Buf* pmem, const char* section_name, ArrX* arr );
  void  IniFile_Read_getPathesS( IniFile_Read*, StrX_Mem* mem,
    const char* section_name, StrX_Set* set );
  char*  IniFile_Read_getMultiLine( IniFile_Read*, const char* attr_name,
    char* retStr, char* buf, int buf_sizeof );
  void  IniFile_Read_getMultiLineM( IniFile_Read*, StrX_Mem* mem,
    const char* attr_name, char* retStr, char** var );
  void  IniFile_Read_getMultiStr( IniFile_Read*, StrX_Mem* buf,
   const char* attr_name, StrX_Set* set );
  void  IniFile_Read_getMultiStrM( IniFile_Read*, const char* attr_name,
   StrX_Mem* buf );
 #endif
 #ifdef  USES_STRV
  void  IniFile_Read_getMultiStrV( IniFile_Read*, StrV_Mem* buf,
    const char* attr_name, StrV_Set* set );
  void  IniFile_Read_getMultiStrAV( IniFile_Read*,
    const char* attr_name, ArrX_Able* set );
 #endif
#endif


/* p */
char* IniFile_Read_readAttrName( IniFile_Read*, const char* attr_name );
void  IniFile_Read_readVar( IniFile_Read*, char* buf,
  const char* types, va_list va );
#ifdef  USES_STRX
 void  IniFile_Read_readVar2( IniFile_Read*, char* buf,
  StrX_Mem* mem, const char* types, va_list va );
 void  IniFile_Read_readVar2_subA( IniFile_Read*, char* vars,
  StrX_Mem* mem, const char* types, va_list va );
 void  IniFile_Read_readVar2_subS( IniFile_Read*, char* buf,
  char** pp, StrX_Mem* mem );
#endif

#ifdef __cplusplus
}
#endif


 
/*---------------------------------------------------------------------*/
/* <<< Mapping Area ----------------------------------------------->>> */ 
/*---------------------------------------------------------------------*/


 
/***********************************************************************
*  <<< [IniFile_Read_readVar2_subS] ^ǂݍރTu֐(StrX_Memgp) >>> 
*yz
*  Echar*  buf;     ^̒li'\0'ŏIj
*  Echar**  pp;     |C^i[AhX
*  EStrX_Mem* mem;  i[̈
************************************************************************/
#define  IniFile_Read_readVar2_subS( this, buf, pp, mem ) \
  { \
    if ( (int)strlen( buf ) > (this)->string_sizeof - 1 ) \
      (buf)[(this)->string_sizeof - 1] = '\0'; \
    *(pp) = StrX_Mem_alloc( mem ); \
    strcpy( *(pp), buf ); \
  }


 
#endif /* __INIFILE_H */ 
 
