/**************************************************************************
*  <<< oϐ̃ItZbg (Offset) >>> 
***************************************************************************/

#include "mixer_precomp.h"  /* Auto precompiled header, Look at mixer-... folder */
// #pragma hdrstop ("mixer_precomp")

#if defined(USES_MXP_AUTOINC)
 #include "offset.ah"  /* Auto include header, Look at mixer-... folder */
#endif
 
/*-------------------------------------------------------------------------*/
/* <<< (Offset_Key) L[ >>>                                       */ 
/*-------------------------------------------------------------------------*/


#ifdef  USES_STDLIBS
#ifndef  USES_MORI_STDLIB
 
/**************************************************************************
*  <<< [Offset_Key_chk] K`FbN >>> 
***************************************************************************/
int  Offset_Key_chk( Offset_Key* m )
{
  return  Offset_chk( m->offset ) &&
    ( m->type == Offset_Int ||
      m->type == Offset_Double ||
      m->type == Offset_CString ||
      m->type == Offset_CStringP ||
      m->type == Offset_CStringPI ||
      m->type == Offset_CStringPW ||
      m->type == Offset_StrV ) &&
    ( m->direc == Offset_Up ||
      m->direc == Offset_Down ||
      m->direc == Offset_NoDirec );
}
 
/*************************************************************************
*  <<< [Offset_Key_isHit] L[qbg邩肷 >>> 
*yz
*  Evoid*  elem;   qbg邩肷vf
*  Evoid*  key;    ɗpL[̒li[ĂAhX
*  Ebool  Ԃl;  qbgǂitrue=qbgj
**************************************************************************/
#ifdef  __STRING_H
#if !defined(FOR_GHS) && !defined(FOR_CA) && !defined(FOR_WINCE)
bool  Offset_Key_isHit( Offset_Key* m, const void* elem, const void* key )
{
  ASSERT( elem != NULL );

  switch ( m->type ) {
    case  Offset_CString:
      return  strcmp( &Offset_ref( m->offset, elem, char ), key ) == 0;
    case  Offset_CStringP:
      ASSERT( Offset_ref( m->offset, elem, char* ) != NULL );
      return  strcmp( Offset_ref( m->offset, elem, char* ), key ) == 0;
    case  Offset_CStringPI:
      ASSERT( Offset_ref( m->offset, elem, char* ) != NULL );
      return  stricmp( Offset_ref( m->offset, elem, char* ), key ) == 0;
    #ifdef  USES_STRX
    case  Offset_CStringPW:
      ASSERT( Offset_ref( m->offset, elem, char* ) != NULL );
      return  StrX_cmpWild( Offset_ref( m->offset, elem, char* ), key ) == 0;
    #endif
    #ifdef  USES_STRV
    case  Offset_StrV:
      return  strcmp( Offset_ref( m->offset, elem, StrV ).p, key ) == 0;
    #endif
    default:
      error();
      return false;  /* dummy */
  }
}
#endif
#endif
 
/**************************************************************************
*  <<< [Offset_Key_cmp] L[r >>> 
*yz
*  Evoid*  data1, data2;   L[܂ރf[^̃AhX
*  Eint  Ԃl;           řʁAdata1 DAdata2 D
*y⑫z
*EL[ int ^̏ꍇAȂAԂl͐łidata1.key < data2.keyjB
***************************************************************************/
int  Offset_Key_cmp( Offset_Key* m, void* data1, void* data2 )
{
  int  flag;

  switch ( m->type ) {
    case Offset_Int:
      flag = Offset_ref( m->offset, data1, int )
           - Offset_ref( m->offset, data2, int );
      break;
    case Offset_Double:
      flag = (int)( Offset_ref( m->offset, data1, double )
                  - Offset_ref( m->offset, data2, double ) );
      break;
    default:
      #ifdef _CHECKER
        error();
      #endif
      break;
  }

  return  flag * m->direc;
}
 
/**************************************************************************
*  <<< [Offset_Key_getCharPtr] L[QƂ >>> 
*yz
*  Evoid*  data;    L[܂ރf[^̃AhX
*  Echar*  Ԃl;   , NULL=łȂ
*y⑫z
*EOffset_CString, Offset_CStringP, Offset_CStringPI, Offset_CStringPW,
*  Offset_StrV ̂ǂ̌^łQƂł܂B
*E^ȊÔƂ NULL Ԃ܂B
***************************************************************************/
char*  Offset_Key_getCharPtr( Offset_Key* m, void* data )
{
  switch ( m->type ) {
    case  Offset_CString:
      return  &Offset_ref( m->offset, data, char );
    case  Offset_CStringP:
    case  Offset_CStringPI:
    case  Offset_CStringPW:
      return  Offset_ref( m->offset, data, char* );
    #ifdef  USES_STRV
    case  Offset_StrV:
      return  Offset_ref( m->offset, data, StrV ).p;
    #endif
    default:
      return  NULL;
  }
}

 
/**************************************************************************
*  <<< [Offset_Key_print] fobO\ >>> 
*yz
*  EOffset_Key*  m;  L[ǐ^j
*  Echar*  title;     sɕ\镶
***************************************************************************/
#ifndef  ERRORS_CUT_DEBUG_TOOL
#ifdef   USES_ARRX
void  Offset_Key_print( Offset_Key* m, const char* title )
{
  static char*  type_str[] = {
    "Offset_Int", "Offset_Double", "Offset_CString", "Offset_CStringP",
    "Offset_CStringPI", "Offset_CStringPW", "Offset_StrV"
  };
  static char*  direc_str[] = {
    "Offset_Up" /*-1*/, "Offset_NoDirec", "Offset_Down"
  };

  if ( m->type >= 0 && m->type < ArrX_C_getN( type_str, char* ) &&
       m->direc >= -1 && m->direc <= 1 ) {
    Errors_printf( "%sKey(%p): offset=%d(0x%X), type=%d(%s), direc=%d(%s)",
      title, m, m->offset, m->offset,
      m->type, type_str[m->type], m->direc, direc_str[m->direc+1] );
  }
  else {
    Errors_printf( "%sKey(%p): offset=%d(0x%X), type=%d, direc=%d",
      title, m, m->offset, m->offset,
      m->type, m->direc );
  }
}
#endif
#endif


 
/**************************************************************************
*  <<< [Offset_Key_printData] Ώۃf[^̃L[̒l̃fobO\ >>> 
*yz
*  EOffset_Key*  m;  L[ǐ^j
*  Evoid*  data;      L[܂ރf[^̐擪AhX
*  Echar*  title;     sɕ\镶
***************************************************************************/
#ifndef  ERRORS_CUT_DEBUG_TOOL
void  Offset_Key_printData( Offset_Key* m, void* data, const char* title )
{
  switch ( m->type ) {
    case Offset_Int:
      Errors_printf( "%sData of Key (%p) = %d", title, data,
        Offset_ref( m->offset, data, int ) );
      break;
    case Offset_Double:
      Errors_printf( "%sData of Key (%p) = %f", title, data,
        Offset_ref( m->offset, data, double ) );
      break;
    case Offset_CString:
      Errors_printf( "%sData of Key (%p) = %s", title, data,
        &Offset_ref( m->offset, data, char ) );
      break;
    case Offset_CStringP:
    case Offset_CStringPI:
    case Offset_CStringPW:
      Errors_printf( "%sData of Key (%p) = %s", title, data,
        Offset_ref( m->offset, data, char* ) );
      break;
    /* default was ignore */
  }
}
#endif


 
#endif  /* USES_MORI_STDLIB */ 
#endif  /* USES_STDLIBS */

 
